﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;
using System.Reflection;


namespace MyNote001
{
    /*
    class QueueMouseMoveForDrawLine
    {
        private Layer layer;
        private int alpha;
        private int[] colors;
        private Point start_DRAW;
        private Point end;
        private int penSize;

        public QueueMouseMoveForDrawLine(Layer layer, int alpha, int[] colors, Point start_DRAW, Point end, int penSize)
        {
            this.layer = layer; // 参照を保存
            this.alpha = alpha; // 値渡し
            this.colors = new int[3];
            this.colors[0] = colors[0]; // 値渡し
            this.colors[1] = colors[1];
            this.colors[2] = colors[2];
            this.start_DRAW = start_DRAW; // 構造体は値型
            this.end = end;
            this.penSize = penSize;
        }

        public Layer Layer
        {
            get { return this.layer; }
        }

        public int Alpha
        {
            get { return this.alpha; }
        }

        public int[] Colors
        {
            get { return this.colors;}
        }

        public Point Start
        {
            get { return this.start_DRAW; }
        }

        public Point End
        {
            get { return this.end; }
        }

        public int PenSize
        {
            get { return this.penSize; }
        }


    }
    */

    public partial class Form1 : Form
    {
        /*
        private Thread trd;
        private Queue<QueueMouseMoveForDrawLine> queueMouseMoveForDrawLine;
        */

        test t = null;

        enum StateOfRotate { ROTATE000, ROTATE090, ROTATE180, ROTATE270 };
        StateOfRotate nowStateOfRotate;

        int PageWidth = 400;
        int PageHeight = 300;
        const int MinWH = 50;
        const int MaxWH = 2000;

        const int minPenSize = 0;
        const int maxPenSize = 64;

        
        const int transparent = 0xfe;
        //const double transparent2 = 0.01;

        // Blackが0x000000だと、cmykの混色でうまくいかない
        enum MyColor {WHITE = 0xffffff, TRANSPARENT = transparent * 0x10000 + transparent * 0x100 + transparent, BLACK = 0x050505, GLAY = 0x777777, RED = 0xff0000, GREEN = 0x00ff00, BLUE = 0x0000ff,
                        YELLOW  = 0xffff00, CYAN = 0x00ffff, MAGENTA  = 0xff00ff};
        enum MyAlpha { HIGH = 255, HM = 191, MIDDLE = 127, ML = 63, LOW = 0 };
        int alpha = (int)MyAlpha.HIGH;
        // setColorsFromRgb() で設定する
        int[] myColor;

        const System.Drawing.Imaging.PixelFormat FORMAT = System.Drawing.Imaging.PixelFormat.Format32bppArgb;

        Layer layer1;
        Layer layer2;
        Layer layer3;
        Layer layer4;
        Layer layermerge;
        Layer targetLayer;

        Layer.DrawLinePenKind layerdrawlinepenkind;



        int penSize = 8;

        enum PENMODE { DRAW, LINE, ELLIPSE, STAMP_DDC, COPY_TO_CLIPBOARD };
        PENMODE penmode;

        // for PENMODE.DRAW
        bool start_DRAW = false;  // true = 描画中
        Point startP_DRAW;     // 起点

        bool key_space = false; // true = 押下中

        //Rectangle layerRect;
        //Rectangle realRect;
        // for PENMODE.LINE PENMODE.ELLIPSE
        bool start_OTHER = false;  // true = 始点 確定
        bool end_OTHER = false;    // true = 終点 確定
        Point startP_OTHER_REAL;     
        Point endP_OTHER_REAL;
        Point startP_OTHER_LAYER;
        Point endP_OTHER_LAYER;

        Bitmap laster_a;
        Bitmap laster_b;

        // 「TickCount プロパティの解像度は、500 ミリ秒未満には設定できません。」
        int seedForRandom = Environment.TickCount;
        int seedStep = 109; // 適当に選んだ素数。271。
        Random rnd;

        enum BITMAP_COPY_MODE { CENTER, TILES, STRETCH };
        BITMAP_COPY_MODE bitmapcopymode;

        enum LAYERS_MERGE_MODE { SIMPLEMIXER, CELLGA, CELLGA2 };
        LAYERS_MERGE_MODE layersmergemode;

        enum SHOWMODE { MERGE, LAYERONLY };
        SHOWMODE showmode;

        // dllのため
        object userpenkind;
        MethodInfo userpenkindmethod1;
        MethodInfo userpenkindmethod2;

        int counterUserPenKind;

        bool Resizeable = true;


        int keyarrowx;
        int keyarrowy;

        MyMacros mymacros;

        double d_zoom = 1.0;

        public Form1()
        {
            InitializeComponent();

            mymacros = MyMacros.Singleton(this);

            this.pictureBox1.Size = new System.Drawing.Size(PageWidth, PageHeight);

            pictureBoxPenColor.BackColor = Color.White;
            pictureBoxPenColor.Image = new Bitmap(pictureBoxPenColor.Size.Width,
                pictureBoxPenColor.Size.Height - 5,
                FORMAT);

            myColor = new int[3];
            setColorsFromRgb(myColor, (int)MyColor.TRANSPARENT);

            this.nowStateOfRotate = StateOfRotate.ROTATE000;
            this.r000ToolStripMenuItem.Checked = true;

            int[] layerTransparent = { transparent, transparent, transparent };
            alpha = (int)MyAlpha.LOW; // アルファLowで作成。
            this.layer1 = new Layer(PageWidth, PageHeight, alpha, myColor, layerTransparent);
            this.layer2 = new Layer(PageWidth, PageHeight, alpha, myColor, layerTransparent);
            this.layer3 = new Layer(PageWidth, PageHeight, alpha, myColor, layerTransparent);
            this.layer4 = new Layer(PageWidth, PageHeight, alpha, myColor, layerTransparent);
            // layermaregeではlayerTransparentは意味を成さない。そういう使い方をする。が、起動時はこれになるはず。アルファ値は意味をなす。pngだから。
            this.layermerge = new Layer(PageWidth, PageHeight, alpha, myColor, layerTransparent);
            alpha = (int)MyAlpha.HIGH;
            layer1.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
            dDML1SimpleMixToolStripMenuItem.Checked = true;
            layer2.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
            dDML2SimpleMixToolStripMenuItem.Checked = true;
            layer3.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
            dDML3SimpleMixToolStripMenuItem.Checked = true;
            layer4.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
            dDML4SimpleMixToolStripMenuItem.Checked = true;
            // layermaregeではLayer.DotDrawModeは使わない。

            dDMSimpleMixToolStripMenuItem.Checked = true;
            dDML1ToolStripMenuItem.Visible = false;
            dDML2ToolStripMenuItem.Visible = false;
            dDML3ToolStripMenuItem.Visible = false;
            dDML4ToolStripMenuItem.Visible = false;

            dDMSMMiddleToolStripMenuItem.Checked = true;

            layer1.SetDDMSM_Rate(Layer.DDMSM_Middle);
            layer2.SetDDMSM_Rate(Layer.DDMSM_Middle);
            layer3.SetDDMSM_Rate(Layer.DDMSM_Middle);
            layer4.SetDDMSM_Rate(Layer.DDMSM_Middle);

            this.targetLayer = layer1;
            this.layer1ToolStripMenuItem.Checked = true;
            this.laster_a = new Bitmap(PageWidth, PageHeight, FORMAT);
            this.laster_b = new Bitmap(PageHeight, PageWidth, FORMAT);
            this.pictureBox1.Image = laster_a;

            //layerRect = new Rectangle();
            //realRect = new Rectangle();

            setColorsFromRgb(myColor, (int)MyColor.BLUE);

            bitmapcopymode = BITMAP_COPY_MODE.TILES;
            loadModeTilesToolStripMenuItem.Checked = true;

            layersmergemode = LAYERS_MERGE_MODE.CELLGA2;
            lmmCellga2ToolStripMenuItem.Checked = true;

            showmode = SHOWMODE.MERGE;
            showModeMergeToolStripMenuItem.Checked = true;

            penmode = PENMODE.DRAW;
            penModeDrawToolStripMenuItem.Checked = true;

            rnd = new Random(seedForRandom + seedStep);

            lDLPKFIXSQUAREFILLToolStripMenuItem.Checked = true;
            layerdrawlinepenkind = Layer.DrawLinePenKind.FIX_SQUARE_FILL;

            // 使わない
            testButton.Visible = false;
            formWakuToolStripMenuItem.Visible = false;

            this.KeyPreview = true;

            setLabelSizeInfo();

            comboBoxAat.SelectedIndex = 0;


            this.MinimumSize = new Size(this.Width/10, this.Height/10);
            pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;

            initFavoriteColors();
            
        }



        private void Form1_Load(object sender, EventArgs e)
        {
            /*
            queueMouseMoveForDrawLine = new Queue<QueueMouseMoveForDrawLine>();

            trd = new Thread(new ThreadStart(this.ThreadTask));
            trd.IsBackground = true;
            trd.Start();
            */

            loadUserPenKindDll();

        }

        private void loadUserPenKindDll()
        {
            try
            {
                Assembly dll = Assembly.Load("MynUserPenKind");
                Type type = dll.GetType("MynUserPenKind.UserPenKind");

                userpenkind = Activator.CreateInstance(type);
                userpenkindmethod1 = type.GetMethod("method1");
                userpenkindmethod2 = type.GetMethod("method2");

                if (userpenkindmethod1 == null || userpenkindmethod2 == null)
                {
                    MessageBox.Show("失敗", "methodの読み込みに失敗しました");

                    // メニューなどを無効にする。
                    userPenKindEnabledFalse();
                }

                
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString(), "dllの読み込みなどに失敗しました");
                
                // メニューなどを無効にする。
                userPenKindEnabledFalse();

            }
        }

        private void userPenKindEnabledFalse()
        {
            lDLPKUSERPENKINDToolStripMenuItem.Enabled = false;
            lDLPKUPKMETHOD1ToolStripMenuItem.Enabled = false;
            lDLPKUPKMETHOD2ToolStripMenuItem.Enabled = false;
        }

        /*
        private void ThreadTask()
        {
            while (true)
            {
                QueueMouseMoveForDrawLine qmmfdl;

                try
                {
                    qmmfdl = queueMouseMoveForDrawLine.Dequeue();
                    Rectangle rct = qmmfdl.Layer.DrawLine(qmmfdl.Alpha, qmmfdl.Colors, qmmfdl.Start, qmmfdl.End, qmmfdl.PenSize);
                    mergeLayersAndSetPictureBox1Image(rct);
                }
                catch (InvalidOperationException e)
                {
                    // なにもしない。
                }

                Thread.Sleep(3);
            }
        }
        */


        private void rotateToolStripMenuItemUncheck()
        {
            this.r000ToolStripMenuItem.Checked = false;
            this.r090ToolStripMenuItem.Checked = false;
            this.r180ToolStripMenuItem.Checked = false;
            this.r270ToolStripMenuItem.Checked = false;
        }

        private void r000ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.rotateToolStripMenuItemUncheck();
            this.r000ToolStripMenuItem.Checked = true;
            this.nowStateOfRotate = StateOfRotate.ROTATE000;
            this.pictureBox1.Size = new System.Drawing.Size(PageWidth, PageHeight);
            this.pictureBox1.Image = laster_a;
            
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            ////mergeLayersAndSetPictureBox1Image(rect);
            //setPictureBox1Image(rect);
            fullSetPictureBox_so_cursor();
        }

        private void r090ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.rotateToolStripMenuItemUncheck();
            this.r090ToolStripMenuItem.Checked = true;
            this.nowStateOfRotate = StateOfRotate.ROTATE090;
            this.pictureBox1.Size = new System.Drawing.Size(PageHeight, PageWidth);
            this.pictureBox1.Image = laster_b;
            
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            ////mergeLayersAndSetPictureBox1Image(rect);
            //setPictureBox1Image(rect);
            fullSetPictureBox_so_cursor();
        }

        private void r180ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.rotateToolStripMenuItemUncheck();
            this.r180ToolStripMenuItem.Checked = true;
            this.nowStateOfRotate = StateOfRotate.ROTATE180;
            this.pictureBox1.Size = new System.Drawing.Size(PageWidth, PageHeight);
            this.pictureBox1.Image = laster_a;
            
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            ////mergeLayersAndSetPictureBox1Image(rect);
            //setPictureBox1Image(rect);
            fullSetPictureBox_so_cursor();
        }

        private void r270ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.rotateToolStripMenuItemUncheck();
            this.r270ToolStripMenuItem.Checked = true;
            this.nowStateOfRotate = StateOfRotate.ROTATE270;
            this.pictureBox1.Size = new System.Drawing.Size(PageHeight, PageWidth);
            this.pictureBox1.Image = laster_b;
            
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            ////mergeLayersAndSetPictureBox1Image(rect);
            //setPictureBox1Image(rect);
            fullSetPictureBox_so_cursor();
        }



        // layerで考えて描き換えたい範囲を引数にする
        private void mergeLayersAndSetPictureBox1Image(Rectangle rect)
        {
            mergeLayers(rect);
            setPictureBox1Image(rect);
        }

        // layerで考えて描き換えたい範囲を引数にする
        private void mergeLayers(Rectangle rect)
        {
            Debug.WriteLine(rect.ToString());
            int sx = rect.Left;
            int sy = rect.Top;
            int ex = rect.Left + rect.Width;
            int ey = rect.Top + rect.Height;
            if (sx < 0) sx = 0;
            if (sy < 0) sy = 0;
            if (ex > PageWidth) ex = PageWidth;
            if (ey > PageHeight) ey = PageHeight;

            // layermergeの描き変え範囲を用意する。
            Layer[] layers = { layer1, layer2, layer3, layer4 };
            for (int x = sx; x < ex; x++)
            {
                for (int y = sy; y < ey; y++)
                {
                    //double[] cmyk1 = RGBtoCMYK(layer1.GetDotRed(x, y), layer1.GetDotGreen(x, y), layer1.GetDotBlue(x, y));
                    //double[] cmyk2 = RGBtoCMYK(layer2.GetDotRed(x, y), layer2.GetDotGreen(x, y), layer2.GetDotBlue(x, y));
                    //double[] cmyk3 = RGBtoCMYK(layer3.GetDotRed(x, y), layer3.GetDotGreen(x, y), layer3.GetDotBlue(x, y));
                    //double[] cmyk4 = RGBtoCMYK(layer4.GetDotRed(x, y), layer4.GetDotGreen(x, y), layer4.GetDotBlue(x, y));
                    //double[] cmyk = MixCMYK(MixCMYK(cmyk1, cmyk2), MixCMYK(cmyk3, cmyk4));
                    //int a = (layer1.GetDotAlpha(x,y) + layer2.GetDotAlpha(x,y) + layer3.GetDotAlpha(x,y) + layer4.GetDotAlpha(x,y) ) / 4;
                    //int[] tmp = CMYKtoRGB(cmyk);
                    //layermerge.SetDot(x, y, a, tmp);
                    int[] argb = getMixedArgbFromLayerDots(layers, x, y);
                    int[] tmpcolors = { argb[1], argb[2], argb[3] };
                    layermerge.SetDot(x, y, argb[0], tmpcolors);
                }
            }
        }

        // layerで考えて描き換えたい範囲を引数にする
        private void setPictureBox1Image(Rectangle rect)
        {
            Layer layer = layermerge;

            if (showmode == SHOWMODE.MERGE)
            {
                layer = layermerge;
            }
            else if (showmode == SHOWMODE.LAYERONLY)
            {
                layer = targetLayer;
            }


            Debug.WriteLine(rect.ToString());
            int sx = rect.Left;
            int sy = rect.Top;
            int ex = rect.Left + rect.Width;
            int ey = rect.Top + rect.Height;
            if (sx < 0) sx = 0;
            if (sy < 0) sy = 0;
            if (ex > PageWidth) ex = PageWidth;
            if (ey > PageHeight) ey = PageHeight;

            // Bitmapにマッピングする。
            for (int x = sx; x < ex; x++)
            {
                for (int y = sy; y < ey; y++)
                {
                    Color tmpColor = Color.FromArgb(layer.GetDotAlpha(x, y),layer.GetDotRed(x, y),layer.GetDotGreen(x, y),layer.GetDotBlue(x, y));
                    if (this.nowStateOfRotate == StateOfRotate.ROTATE000)
                    {
                        int x2 = x;
                        int y2 = y;
                        laster_a.SetPixel(x2, y2, tmpColor);
                    } else if(this.nowStateOfRotate == StateOfRotate.ROTATE090)
                    {
                        int x2 = y;
                        int y2 = PageWidth - x - 1;
                        laster_b.SetPixel(x2, y2, tmpColor);
                    } else if (this.nowStateOfRotate == StateOfRotate.ROTATE180)
                    {
                        int x2 = PageWidth - x -1;
                        int y2 = PageHeight - y - 1;
                        laster_a.SetPixel(x2, y2, tmpColor);
                    } else if (this.nowStateOfRotate == StateOfRotate.ROTATE270)
                    {
                        int x2 = PageHeight - y -1;
                        int y2 = x;
                        laster_b.SetPixel(x2, y2, tmpColor);
                    }
                }
            }

            Rectangle realRect = layerRectToRealRect(rect);
            pictureBox1.Invalidate(realRect);
            pictureBox1.Update();
            String str = String.Format("{0}, {1}, {2}, {3}", realRect.X, realRect.Y, realRect.Width, realRect.Height);
            Debug.WriteLine(str);
        }

        private Rectangle layerRectToRealRect(Rectangle rect)
        {
            int smallX = rect.X;
            int smallY = rect.Y;
            int largeX = rect.X + rect.Width - 1;
            int largeY = rect.Y + rect.Height - 1;
            Rectangle r = new Rectangle();
            if (this.nowStateOfRotate == StateOfRotate.ROTATE000)
            {
                r.X = smallX;
                r.Y = smallY;
                r.Width = rect.Width;
                r.Height = rect.Height;
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE090)
            {
                r.X = smallY;
                r.Y = PageWidth - largeX - 1;
                r.Width = rect.Height;
                r.Height = rect.Width;
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE180)
            {
                r.X = PageWidth - largeX - 1;
                r.Y = PageHeight - largeY - 1;
                r.Width = rect.Width;
                r.Height = rect.Height;
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE270)
            {
                r.X = PageHeight - largeY - 1;
                r.Y = smallX;
                r.Width = rect.Height;
                r.Height = rect.Width;
            }

            {
                r.X = (int)Math.Floor(r.X * d_zoom);
                r.Y = (int)Math.Floor(r.Y * d_zoom);
                r.Width = (int)Math.Ceiling(r.Width * d_zoom);
                r.Height = (int)Math.Ceiling(r.Height * d_zoom);
            }

            int temp = 10;
            {
                r.X = r.X - temp;
                r.Y = r.Y - temp;
                r.Width = r.Width + temp * 3;
                r.Height = r.Height + temp * 3;
            }

            return r;
        }

        // ///////////////////////////////////////////////////////////////////////

        private int[] getMixedArgbFromLayerDots(Layer[] layers, int x, int y)
        {
            int[] result = new int[4];
            result[0] = layers[0].GetDotAlpha(x,y);
            result[1] = layers[0].GetDotRed(x, y);
            result[2] = layers[0].GetDotGreen(x, y);
            result[3] = layers[0].GetDotBlue(x, y);
            for (int i = 0; i < layers.Length - 1; i++)
            {
                result = getMixedArgbFrom2Argb(result, layers[i + 1].GetDotARGB(x, y));
            }
            return result;
        }

        // argb2がレイヤー番号大きい方
        private int[] getMixedArgbFrom2Argb(int[] argb1, int[] argb2)
        {
            int[] resultArgb = new int[4];
            int[] argb1colors = { argb1[1], argb1[2], argb1[3] };
            int[] argb2colors = { argb2[1], argb2[2], argb2[3] };
            if (IsColorsTransparent(argb1colors))
            {
                // 片方が透明色ならもう一方を
                resultArgb[0] = argb2[0];
                resultArgb[1] = argb2[1];
                resultArgb[2] = argb2[2];
                resultArgb[3] = argb2[3];
            }
            else if (IsColorsTransparent(argb2colors))
            {
                // 片方が透明色ならもう一方を
                resultArgb[0] = argb1[0];
                resultArgb[1] = argb1[1];
                resultArgb[2] = argb1[2];
                resultArgb[3] = argb1[3];
            }
            else
            {
                // 両方とも透明色ではない。
                if (layersmergemode == LAYERS_MERGE_MODE.SIMPLEMIXER)
                {
                    // alpha
                    resultArgb[0] = (argb1[0] + argb2[0]) / 2;
                    // rgb
                    double[] cmyk1 = RGBtoCMYK(argb1[1], argb1[2], argb1[3]);
                    double[] cmyk2 = RGBtoCMYK(argb2[1], argb2[2], argb2[3]);
                    double[] mixedcmyk = MixCMYK(cmyk1, cmyk2);
                    int[] tmpcolors = CMYKtoRGB(mixedcmyk);
                    resultArgb[1] = tmpcolors[0];
                    resultArgb[2] = tmpcolors[1];
                    resultArgb[3] = tmpcolors[2];
                }
                else if (layersmergemode == LAYERS_MERGE_MODE.CELLGA)
                {
                    // 番号の大きい方のレイヤー
                    resultArgb[0] = argb2[0];
                    resultArgb[1] = argb2[1];
                    resultArgb[2] = argb2[2];
                    resultArgb[3] = argb2[3];
                }
                else if (layersmergemode == LAYERS_MERGE_MODE.CELLGA2)
                {
                    // alpha
                    resultArgb[0] = Math.Max(argb1[0], argb2[0]);
                    // rgb
                    double[] cmyk1 = RGBtoCMYK(argb1[1], argb1[2], argb1[3]);
                    double[] cmyk2 = RGBtoCMYK(argb2[1], argb2[2], argb2[3]);
                    double[] mixedcmyk = MixCMYKwithAlpha(argb1[0], cmyk1, argb2[0], cmyk2);
                    int[] tmpcolors = CMYKtoRGB(mixedcmyk);
                    resultArgb[1] = tmpcolors[0];
                    resultArgb[2] = tmpcolors[1];
                    resultArgb[3] = tmpcolors[2];
                }
            }
            return resultArgb;
        }

        private bool IsColorsTransparent(int[] colors)
        {
            bool result = false;
            if ( transparent == colors[0] && transparent == colors[1] && transparent == colors[2])
            {
                result = true;
            }
            return result;
        }

        private double[] RGBtoCMYK(int red, int green, int blue)
        {
            double dred = red;
            double dgreen = green;
            double dblue = blue;
            double[] cmyk = new double[4];
            double black = Math.Min(1 - dred / 255, Math.Min(1 - dgreen / 255, 1 - dblue / 255));
            cmyk[0] = (1 - (dred / 255) - black) / (1 - black);
            cmyk[1] = (1 - (dgreen / 255) - black) / (1 - black);
            cmyk[2] = (1 - (dblue / 255) - black) / (1 - black);
            cmyk[3] = black;

            //if (transparent == red && transparent == green && transparent == white)
            //{
            //    cmyk[0] = transparent2;
            //    cmyk[1] = transparent2;
            //    cmyk[2] = transparent2;
            //    cmyk[3] = transparent2;
            //}
            return cmyk;
        }

        //private bool IsTransparent2(double[] cmyk)
        //{
        //    bool result = false;
        //    if (cmyk[0] == transparent2 && cmyk[1] == transparent2 && cmyk[2] == transparent2 && cmyk[3] == transparent2)
        //    {
        //        result = true;
        //    }
        //    return result;
        //}


        // alpha1はとりあえず使わない。
        private double[] MixCMYKwithAlpha(int alpha1, double[] cmyk1, int alpha2, double[] cmyk2)
        {
            double[] cmyk = new double[4];

            for (int i = 0; i < 4; i++)
            {
                int alpha_max = 255;
                cmyk[i] = cmyk1[i] * (alpha_max - alpha2) / alpha_max +
                    cmyk2[i] * alpha2 / alpha_max;
                if (cmyk[i] > 1) cmyk[i] = 1.0;
                if (cmyk[i] < 0) cmyk[i] = 0.0;
            }

            return cmyk;
        }

        private double[] MixCMYK(double[] cmyk1, double[] cmyk2)
        {
            double[] cmyk = new double[4];

            //if (IsTransparent2(cmyk1)){
            //    cmyk[0]= cmyk2[0];
            //    cmyk[1]= cmyk2[1];
            //    cmyk[2]= cmyk2[2];
            //    cmyk[3]= cmyk2[3];
            //}
            //else if (IsTransparent2(cmyk2))
            //{
            //    cmyk[0] = cmyk1[0];
            //    cmyk[1] = cmyk1[1];
            //    cmyk[2] = cmyk1[2];
            //    cmyk[3] = cmyk1[3];
            //}
            //else
            //{
                for (int i = 0; i < 4; i++)
                {
                    double large = Math.Max(cmyk1[i], cmyk2[i]);
                    double small = Math.Min(cmyk1[i], cmyk2[i]);

                    //cmyk[i] = small + (large - small) * (1.0 - (large - small));
                    //cmyk[i] = large + (large - small) * (1.0 - (large - small));

                    cmyk[i] = (cmyk1[i] + cmyk2[i]) / 2;
                    if (cmyk[i] > 1) cmyk[i] = 1.0;
                    if (cmyk[i] < 0) cmyk[i] = 0.0;
                }
            //}  
            return cmyk;
        }

        private int[] CMYKtoRGB(double[] cmyk)
        {
            int[] colors = new int[3];
            //if (IsTransparent2(cmyk))
            //{
            //    colors[0] = colors[1] = colors[2] = transparent;
            //    return colors;
            //}
            //else
            //{
                double cyan = cmyk[0];
                double magenta = cmyk[1];
                double yellow = cmyk[2];
                double black = cmyk[3];
                int red = (int)((1 - Math.Min(1, cyan * (1 - black) + black)) * 255);
                int green = (int)((1 - Math.Min(1, magenta * (1 - black) + black)) * 255);
                int blue = (int)((1 - Math.Min(1, yellow * (1 - black) + black)) * 255);
                if (red < 0) red = 0;
                if (green < 0) green = 0;
                if (blue < 0) blue = 0;
                if (red > 255) red = 255;
                if (green > 255) green = 255;
                if (blue > 255) blue = 255;
                colors[0] = red; colors[1] = green; colors[2] = blue;
                return colors;
            //}
        }



// // // // // // // // // // // // // // // // // // 

        private void test_Click(object sender, EventArgs e)
        {
            this.t = new test(this);
            this.t.Visible = true;
        }

        public void test_test01_click()
        {
            Rectangle rect = new Rectangle(30, 30, 300, 300);
            for (int x = rect.Left; x < rect.Left + rect.Width; x++)
            {
                for (int y = rect.Top; y < rect.Top + rect.Height; y++)
                {
                    int tmp = 0x00ff00 + (x % 0x100) * 0x10000 + (y % 0x100);
                    this.layer1.SetDot(x, y, alpha, colorsFromRgb(tmp));
                }
            }
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_test02_click()
        {
            Rectangle rect = new Rectangle(80, 80, 350, 350);
            for (int x = rect.Left; x < rect.Left + rect.Width; x++)
            {
                for (int y = rect.Top; y < rect.Top + rect.Height; y++)
                {
                    this.layer2.SetDot(x, y, alpha, colorsFromRgb(0xffff00));
                }
            }
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_test03_click()
        {
            Rectangle rect = new Rectangle(80, 80, 350, 350);
            for (int x = rect.Left; x < rect.Left + rect.Width; x++)
            {
                for (int y = rect.Top; y < rect.Top + rect.Height; y++)
                {
                    this.layer2.SetDot(x, y, alpha, colorsFromRgb((int)MyColor.TRANSPARENT));
                }
            }
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_test04_click()
        {
            Rectangle rect = new Rectangle(80, 80, 350, 350);
            for (int x = rect.Left; x < rect.Left + rect.Width; x++)
            {
                for (int y = rect.Top; y < rect.Top + rect.Height; y++)
                {
                    this.layer2.SetDot(x, y, alpha, myColor);
                }
            }
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_refresh_click()
        {
            Rectangle rect = new Rectangle(0,0,PageWidth,PageHeight);
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_cmykgrb_click()
        {
            int[] colors = {236, 64, 24};
            double[] cmyk = RGBtoCMYK(colors[0], colors[1], colors[2]);
            int[] c = CMYKtoRGB(cmyk);
            string s = String.Format("{0} {1} {2}", c[0], c[1], c[2]);
            MessageBox.Show(s);
            
        }

        public void test_mixcmyk_click()
        {
            double[] cmyk1 = { 0.5, 0.6, 0.4, 0.1 };
            double[] cmyk2 = { 0.4, 0.3, 0.5, 0.3 };
            double[] d = MixCMYK(cmyk1, cmyk2);
            string s = String.Format("{0}, {1}, {2}, {3}", d[0], d[1], d[2], d[3]);
            MessageBox.Show(s);
        }

        public void test_invalUp_click()
        {
            Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            pictureBox1.Invalidate(rect);
            pictureBox1.Update();
        }

        public void test_tiles_click()
        {
            Rectangle rect = new Rectangle(0, 0, 100, 100);
            Layer[] layers = { layer1, layer2, layer3, layer4 };
            int step = 100;
            tileAction(layers,step);
        }

        private void tileAction(Layer[] layers, int step)
        {
            Rectangle rect = new Rectangle();
            rect.Width = rect.Height = step;
            for (int x = 0; x < PageWidth; x = x + step)
            {
                for (int y = 0; y < PageHeight; y = y + step)
                {
                    rect.X = x;
                    rect.Y = y;
                    for (int i = 0; i < layers.Length; i++)
                    {
                        // 結果は利用しない。
                        layers[i].FillRectangle(GetRandomAlpha(1), GetRandomColors(0), rect);
                        //mergeLayersAndSetPictureBox1Image(rect); 
                    }
                    mergeLayersAndSetPictureBox1Image(rect);
                }
            }
        }

        public void test_tile_click()
        {
            Rectangle rect = new Rectangle(0, 0, 100, 100);
            //Rectangle rect1 = layer1.FillRectangle(GetRandomAlpha(), GetRandomColors(), rect);
            //mergeLayersAndSetPictureBox1Image(rect1);
            //Rectangle rect2 = layer2.FillRectangle(GetRandomAlpha(), GetRandomColors(), rect);
            //mergeLayersAndSetPictureBox1Image(rect2);
            //Rectangle rect3 = layer3.FillRectangle(GetRandomAlpha(), GetRandomColors(), rect);
            //mergeLayersAndSetPictureBox1Image(rect3);
            //Rectangle rect4 = layer4.FillRectangle(GetRandomAlpha(), GetRandomColors(), rect);
            //mergeLayersAndSetPictureBox1Image(rect4);
            Debug.WriteLine("start---------------");
            Layer[] layers = { layer1, layer2, layer3, layer4 };
            for (int i = 0; i < layers.Length; i++)
            {
                layers[i].FillRectangle(GetRandomAlpha(1), GetRandomColors(0), rect);
                //Debug.WriteLine("----");
                //String str = String.Format("{0}, {1}, {2}, {3}", layers[1].GetDotAlpha(0, 0), layers[0].GetDotRed(0, 0), layers[0].GetDotGreen(0, 0), layers[0].GetDotBlue(0, 0));
                //Debug.WriteLine(str);
                //mergeLayersAndSetPictureBox1Image(rect);
                //str = String.Format("{0}, {1}, {2}, {3}", layers[1].GetDotAlpha(0, 0), layers[0].GetDotRed(0, 0), layers[0].GetDotGreen(0, 0), layers[0].GetDotBlue(0, 0));
                //Debug.WriteLine(str);
            }
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_Load1_click()
        {
            Bitmap from = getBitmap_OpenFileDialog();
            if ( from == null ) return;
            Bitmap to = new Bitmap(PageWidth, PageHeight, FORMAT);
            bitmapCopyWithMode(from, to, BITMAP_COPY_MODE.TILES);
            layer1.SetFromBitmap(to);
            Rectangle rect = new Rectangle(0,0,PageWidth,PageHeight);
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_Load2_click()
        {
            Bitmap from = getBitmap_OpenFileDialog();
            if (from == null) return;
            Bitmap to = new Bitmap(PageWidth, PageHeight, FORMAT);
            bitmapCopyWithMode(from, to, BITMAP_COPY_MODE.STRETCH);
            layer2.SetFromBitmap(to);
            Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_SaveMerge_click()
        {
            saveLayer_SaveFileDaialog(layermerge);
        }

        public void test_Load3_click()
        {
            Bitmap from = getBitmap_OpenFileDialog();
            if (from == null) return;
            Bitmap to = new Bitmap(PageWidth, PageHeight, FORMAT);
            bitmapCopyWithMode(from, to, BITMAP_COPY_MODE.CENTER);
            layer3.SetFromBitmap(to);
            Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            mergeLayersAndSetPictureBox1Image(rect);
        }

        public void test_setLayer1DotDrawModeSimpleMix_click()
        {
            layer1.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
        }

        // //////////////////////////////////////////////////////

        private int GetRandomAlpha(int subtract)
        {
            int alpha;
            // Random rnd = new Random(seedForRandom += seedStep);
            switch (rnd.Next(5 - subtract))
            {
                case 0: alpha = (int)MyAlpha.HIGH; break;
                case 1: alpha = (int)MyAlpha.HM; break;
                case 2: alpha = (int)MyAlpha.MIDDLE; break;
                case 3: alpha = (int)MyAlpha.ML; break;
                case 4: alpha = (int)MyAlpha.LOW; break;
                default: alpha = 255; break;
            }
            return alpha;
        }

        private int[] GetRandomColors(int subtract)
        { 
            MyColor tmpcolor;
            // Random rnd = new Random(seedForRandom += seedStep);
            switch (rnd.Next(7- subtract))
            {
                case 0: tmpcolor = MyColor.RED; break;
                case 1: tmpcolor = MyColor.GREEN; break;
                case 2: tmpcolor = MyColor.BLUE; break;
                case 3: tmpcolor = MyColor.CYAN; break;
                case 4: tmpcolor = MyColor.MAGENTA; break;
                case 5: tmpcolor = MyColor.YELLOW; break;
                case 6: tmpcolor = MyColor.TRANSPARENT; break;
                default: tmpcolor = MyColor.TRANSPARENT; break;
            }
            int[] colors = colorsFromRgb((int)tmpcolor);
            return colors;
        }

        public void test_rndLACP_click()
        {
            rndLayer();
            rndAlpha();
            rndColor();
            rndPensize();

            Object dummy = new Object();
            MouseButtons b = new MouseButtons();
            MouseEventArgs dummyM = new MouseEventArgs(b, 0, 0, 0, 0);
            pictureBox1_MouseMove(dummy, dummyM);
        }

        private void rndPensize()
        {
            // Random rnd = new Random(seedForRandom += seedStep);
            Object dummy = new object();
            EventArgs dummye = new EventArgs();
            switch (rnd.Next(3))
            {
                //case 0: pen1ToolStripMenuItem_Click(dummy, dummye); break;
                //case 1: pen2ToolStripMenuItem_Click(dummy, dummye); break;
                //case 2: pen4ToolStripMenuItem_Click(dummy, dummye); break;
                //case 3: pen8ToolStripMenuItem_Click(dummy, dummye); break;
                //case 4: pen16ToolStripMenuItem_Click(dummy, dummye); break;
                //case 5: pen32ToolStripMenuItem_Click(dummy, dummye); break;
                case 0: pen4ToolStripMenuItem_Click(dummy, dummye); break;
                case 1: pen8ToolStripMenuItem_Click(dummy, dummye); break;
                case 2: pen16ToolStripMenuItem_Click(dummy, dummye); break;
                default: break;
            }
        }

        private void rndColor()
        {
            // Random rnd = new Random(seedForRandom += seedStep);
            Object dummy = new object();
            EventArgs dummye = new EventArgs();
            switch (rnd.Next(10))
            {
                case 0: rEDToolStripMenuItem_Click(dummy, dummye); break;
                case 1: gREENToolStripMenuItem_Click(dummy, dummye); break;
                case 2: bLUEToolStripMenuItem_Click(dummy, dummye); break;
                case 3: cYANToolStripMenuItem_Click(dummy, dummye); break;
                case 4: mAGENTAToolStripMenuItem_Click(dummy, dummye); break;
                case 5: yELLOWToolStripMenuItem_Click(dummy, dummye); break;
                case 6: wHITEToolStripMenuItem_Click(dummy, dummye); break;
                case 7: tRANSToolStripMenuItem_Click(dummy, dummye); break;
                case 8: bLACKToolStripMenuItem_Click(dummy, dummye); break;
                case 9: gLAYToolStripMenuItem_Click(dummy, dummye); break;
                default: break;
            }
        }

        private void rndAlpha()
        {
            // Random rnd = new Random(seedForRandom += seedStep);
            Object dummy = new object();
            EventArgs dummye = new EventArgs();
            switch (rnd.Next(5))
            {
                case 0: hToolStripMenuItem_Click(dummy, dummye); break;
                case 1: hMToolStripMenuItem_Click(dummy, dummye); break;
                case 2: mToolStripMenuItem_Click(dummy, dummye); break;
                case 3: mLToolStripMenuItem_Click(dummy, dummye); break;
                case 4: lToolStripMenuItem_Click(dummy, dummye); break;
                default: break;
            }
        }

        private void rndLayer()
        {
            // Random rnd = new Random(seedForRandom += seedStep);
            Object dummy = new object();
            EventArgs dummye = new EventArgs();
            switch (rnd.Next(4))
            {
                case 0: layer1ToolStripMenuItem_Click(dummy, dummye); break;
                case 1: layer2ToolStripMenuItem_Click(dummy, dummye); break;
                case 2: layer3ToolStripMenuItem_Click(dummy, dummye); break;
                case 3: layer4ToolStripMenuItem_Click(dummy, dummye); break;
                default: break;
            }
        }

// // // // // // // // // // // // // // // // // // 

        private int redFromRgb(int rgb)
        {
            return (rgb & 0x00ff0000) / 0x10000;
        }

        private int greenFromRgb(int rgb)
        {
            return (rgb & 0x00ff00) / 0x100;
        }

        private int blueFromRgb(int rgb)
        {
            return rgb & 0x0000ff;
        }

        private void setColorsFromRgb(int[] colors, int rgb)
        {
            colors[0] = redFromRgb(rgb);
            colors[1] = greenFromRgb(rgb);
            colors[2] = blueFromRgb(rgb);

            Bitmap bmp = (Bitmap)pictureBoxPenColor.Image;
            for (int x = 0; x < bmp.Width; x++)
            {
                for (int y = 0; y < bmp.Height; y++)
                {
                    bmp.SetPixel(x, y, Color.FromArgb(alpha, colors[0], colors[1], colors[2]));
                }
            }
            pictureBoxPenColor.Refresh();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1},{2},{3},{4}", MyMacros.Color, alpha, colors[0], colors[1], colors[2]));
        }

        private int[] colorsFromRgb(int rgb)
        {
            int[] colors = new int[3];
            colors[0] = redFromRgb(rgb);
            colors[1] = greenFromRgb(rgb);
            colors[2] = blueFromRgb(rgb);
            return colors;
        }

        // ////////////////////////////////////////////////

        private void alphaChageToolstripMenuItem_Clicked()
        {
            int rgb = myColor[0] * 0x10000 + myColor[1] * 0x100 + myColor[2];
            setColorsFromRgb(myColor, rgb);
        }

        private void hToolStripMenuItem_Click(object sender, EventArgs e)
        {
            alpha = (int)MyAlpha.HIGH;
            alphaChageToolstripMenuItem_Clicked();
        }

        private void hMToolStripMenuItem_Click(object sender, EventArgs e)
        {
            alpha = (int)MyAlpha.HM;
            alphaChageToolstripMenuItem_Clicked();
        }

        private void mToolStripMenuItem_Click(object sender, EventArgs e)
        {
            alpha = (int)MyAlpha.MIDDLE;
            alphaChageToolstripMenuItem_Clicked();
        }

        private void mLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            alpha = (int)MyAlpha.ML;
            alphaChageToolstripMenuItem_Clicked();
        }

        private void lToolStripMenuItem_Click(object sender, EventArgs e)
        {
            alpha = (int)MyAlpha.LOW;
            alphaChageToolstripMenuItem_Clicked();
        }

        //  ////////////////////////////////////////

        private void wHITEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.WHITE);
        }

        private void tRANSToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.TRANSPARENT);
        }

        private void bLACKToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.BLACK);
        }

        private void gLAYToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.GLAY);
        }

        private void rEDToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.RED);
        }

        private void gREENToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.GREEN);
        }

        private void bLUEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.BLUE);
        }

        private void yELLOWToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.YELLOW);
        }

        private void cYANToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.CYAN);
        }

        private void mAGENTAToolStripMenuItem_Click(object sender, EventArgs e)
        {
            setColorsFromRgb(myColor, (int)MyColor.MAGENTA);
        }

        private void toolStripStatusLabelLACP_info()
        {
            String strLayer = "?";

            if (targetLayer == layer1){
                strLayer = "1";
            } else if (targetLayer == layer2){
                strLayer = "2";
            } else if (targetLayer == layer3){
                strLayer = "3";
            } else if (targetLayer == layer4){
                strLayer = "4";
            }

            String strAlpha = "?";
            strAlpha = alpha.ToString();

            String strColor = String.Format("({0},{1},{2})", myColor[0], myColor[1], myColor[2]);

            String strPensize = penSize.ToString();

            String str = " L" + strLayer + ",A" + strAlpha + ",C" + strColor + ",P" + strPensize;
            toolStripStatusLabelLACP.Text = str;
        }

        private void toolStripStatusLabelLp_info(Point p)
        {
            String strLayerPoint = string.Format("[{0},{1}]", p.X, p.Y);
            toolStripStatusLabelLp.Text = strLayerPoint;
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            Point temp = pictureBoxPointToLayerPoint(e);
            if (penmode == PENMODE.DRAW || penmode == PENMODE.LINE || penmode == PENMODE.ELLIPSE)
            { 
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1},{2}", MyMacros.MouseDown, temp.X, temp.Y));
            }

            if (penmode == PENMODE.DRAW)
            {
                counterUserPenKind = 0;
                Point p = pictureBoxPointToLayerPoint(e);
                start_DRAW = true;
                startP_DRAW = p;
                return;
            }
            else if (penmode == PENMODE.LINE || penmode == PENMODE.ELLIPSE)
            {
                start_OTHER = true;
                startP_OTHER_REAL = new Point(e.X, e.Y);
                startP_OTHER_LAYER = pictureBoxPointToLayerPoint(e);
                return;
            }   
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            Point temp = pictureBoxPointToLayerPoint(e);
            if (penmode == PENMODE.LINE || penmode == PENMODE.ELLIPSE)
            {
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1},{2}", MyMacros.MouseMove, temp.X, temp.Y));
            }
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1},{2}", MyMacros.MouseUp, temp.X, temp.Y));

            if (penmode == PENMODE.DRAW)
            {
                Point p = pictureBoxPointToLayerPoint(e);
                start_DRAW = false;
                return;
            }
            else if (penmode == PENMODE.LINE)
            {
                start_OTHER = false;
                if (end_OTHER == false) return;
                end_OTHER = false;

                if (layerdrawlinepenkind == Layer.DrawLinePenKind.USER_PEN_KIND_METHOD1 || layerdrawlinepenkind == Layer.DrawLinePenKind.USER_PEN_KIND_METHOD2)
                {
                    counterUserPenKind = 0;
                    userPenKind(layerdrawlinepenkind, startP_OTHER_LAYER, endP_OTHER_LAYER);
                }
                else
                {
                    Rectangle rect = targetLayer.DrawLine(alpha, myColor, startP_OTHER_LAYER, endP_OTHER_LAYER, penSize, true, layerdrawlinepenkind);
                    mergeLayersAndSetPictureBox1Image(rect);
                }

                return;
            }
            else if (penmode == PENMODE.ELLIPSE)
            {
                start_OTHER = false;
                if (end_OTHER == false) return;
                end_OTHER = false;

                if (layerdrawlinepenkind == Layer.DrawLinePenKind.USER_PEN_KIND_METHOD1 || layerdrawlinepenkind == Layer.DrawLinePenKind.USER_PEN_KIND_METHOD2)
                {
                    Point[,] points = targetLayer.UserPenKindDrawEllipse(startP_OTHER_LAYER, endP_OTHER_LAYER, penSize);
                    counterUserPenKind = 0; 
                    for (int i = 0; i < points.GetLength(0); i++)
                    {
                        userPenKind(layerdrawlinepenkind, points[i, 0], points[i, 1]);
                        counterUserPenKind++;
                    }
                }
                else
                {
                    Rectangle rect = targetLayer.DrawEllipse(alpha, myColor, startP_OTHER_LAYER, endP_OTHER_LAYER, penSize, layerdrawlinepenkind);
                    mergeLayersAndSetPictureBox1Image(rect);
                }

                return;
            }
            else if (penmode == PENMODE.STAMP_DDC)
            {
                Point p = pictureBoxPointToLayerPoint(e);
                Rectangle rect = targetLayer.StampDDC(alpha, myColor, p);
                mergeLayersAndSetPictureBox1Image(rect);
                return;
            }
            else if (penmode == PENMODE.COPY_TO_CLIPBOARD)
            {
                Point p = pictureBoxPointToLayerPoint(e);
                //Rectangle rect = targetLayer.StampDDC(alpha, myColor, p);
                //mergeLayersAndSetPictureBox1Image(rect);
                string str = "";
                try
                {
                    str = string.Format("{0},{1},{2},{3},{4},{5}", p.X, p.Y,
                        targetLayer.GetDotAlpha(p.X, p.Y),
                        targetLayer.GetDotRed(p.X, p.Y),
                        targetLayer.GetDotGreen(p.X, p.Y),
                        targetLayer.GetDotBlue(p.X, p.Y));
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.ToString());
                }

                try
                {
                    Clipboard.SetText(str);
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.ToString());
                }
                return;
            }
            
            
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            Point temp = pictureBoxPointToLayerPoint(e);
            if (penmode == PENMODE.DRAW && start_DRAW == true)
            {
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1},{2}", MyMacros.MouseMove, temp.X, temp.Y));
            }

            if (e.X >= 0 && e.X <= PageWidth - 1 && e.Y >= 0 && e.Y <= PageHeight - 1)
            {
                toolStripStatusLabelLACP_info();
            }

            Point p = pictureBoxPointToLayerPoint(e);
            toolStripStatusLabelLp_info(p);


            // toolStripStatusLabelArgb
            {
                try
                {
                    String str = String.Format("({0},{1},{2},{3})({4},{5},{6},{7})({8},{9},{10},{11})({12},{13},{14},{15})->({16},{17},{18},{19})",
                        layer1.GetDotAlpha(p.X, p.Y), layer1.GetDotRed(p.X, p.Y), layer1.GetDotGreen(p.X, p.Y), layer1.GetDotBlue(p.X, p.Y),
                        layer2.GetDotAlpha(p.X, p.Y), layer2.GetDotRed(p.X, p.Y), layer2.GetDotGreen(p.X, p.Y), layer2.GetDotBlue(p.X, p.Y),
                        layer3.GetDotAlpha(p.X, p.Y), layer3.GetDotRed(p.X, p.Y), layer3.GetDotGreen(p.X, p.Y), layer3.GetDotBlue(p.X, p.Y),
                        layer4.GetDotAlpha(p.X, p.Y), layer4.GetDotRed(p.X, p.Y), layer4.GetDotGreen(p.X, p.Y), layer4.GetDotBlue(p.X, p.Y),
                        layermerge.GetDotAlpha(p.X, p.Y), layermerge.GetDotRed(p.X, p.Y), layermerge.GetDotGreen(p.X, p.Y), layermerge.GetDotBlue(p.X, p.Y)
                        );
                    toolStripStatusLabelArgb.Text = str;
                }
                catch (Exception exception)
                {
                    // なにもしない
                }
            }

            if (penmode == PENMODE.DRAW)
            {
                // 
                if (start_DRAW == false) return;
                // Point p = pictureBoxPointToLayerPoint(e);

                //targetLayer.DrawLine(alpha, myColor, startP_DRAW, p, penSize);
                //Rectangle rect = rectangleFrom2Point(startP_DRAW, p);
                //rect.Width += penSize;
                //rect.Height += penSize;

                switch (layerdrawlinepenkind)
                {
                    case Layer.DrawLinePenKind.FIX_SQUARE_FILL:
                    case Layer.DrawLinePenKind.UNFIX_RECTANGLE_FILL:
                    case Layer.DrawLinePenKind.CIRCLE_FILL:
                    case Layer.DrawLinePenKind.FUNNY_BUG_UNFIX_RECTANGLE_FILL:
                    case Layer.DrawLinePenKind.FUNNY_BUG2_UNFIX_RECTANGLE_FILL:
                    case Layer.DrawLinePenKind.FUNNY_BUG2B_UNFIX_RECTANGLE_FILL:
                    case Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_CONC:
                    case Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_MID:
                    case Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_SPARSE:
                        Rectangle rect = targetLayer.DrawLine(alpha, myColor, startP_DRAW, p, penSize, false, layerdrawlinepenkind);
                        mergeLayersAndSetPictureBox1Image(rect);
                        break;
                    case Layer.DrawLinePenKind.USER_PEN_KIND_METHOD1:
                    case Layer.DrawLinePenKind.USER_PEN_KIND_METHOD2:
                        userPenKind(layerdrawlinepenkind, startP_DRAW, p);
                        counterUserPenKind++;
                        break;
                    default:
                        break;
                }


                /*
                QueueMouseMoveForDrawLine qmmfdl = new QueueMouseMoveForDrawLine(targetLayer, alpha, myColor, startP_DRAW, p, penSize);
                queueMouseMoveForDrawLine.Enqueue(qmmfdl);
                */

                startP_DRAW = p;

                return;
            }
            else if (penmode == PENMODE.LINE || penmode == PENMODE.ELLIPSE)
            {
                if (start_OTHER == false) return;
                end_OTHER = true;
                endP_OTHER_REAL = new Point(e.X, e.Y);
                endP_OTHER_LAYER = p;
                pictureBox1.Refresh();  // マウスのドラッグ中の直線、楕円表示を要求。pictureBox1_Paintを見よ。
                return;
            }
        }

        private void userPenKind(Layer.DrawLinePenKind dlpk, Point startp, Point endp)
        {
            object[] obj;
            switch (dlpk)
            {
                case Layer.DrawLinePenKind.USER_PEN_KIND_METHOD1:
                    try
                    {
                        obj = (object[])userpenkindmethod1.Invoke(userpenkind, new object[] { startp, endp, penSize, counterUserPenKind }); 
                    }
                    catch (Exception exc)
                    {
                        MessageBox.Show(exc.InnerException.ToString(), "method1");
                        return;
                    }
                    break;
                case Layer.DrawLinePenKind.USER_PEN_KIND_METHOD2:
                    try
                    {
                        obj = (object[])userpenkindmethod2.Invoke(userpenkind, new object[] { startp, endp, penSize, counterUserPenKind });
                    }
                    catch (Exception exc)
                    {
                        MessageBox.Show(exc.InnerException.ToString(), "method2");
                        return;
                    }
                    break;
                default:
                    return;
                    break;
            }

            Rectangle rect = (Rectangle)obj[0];
            bool[,] onOff = (bool[,])obj[1];
            try
            {
                targetLayer.ForUserPenKind(alpha, myColor, rect, onOff);
            }
            catch (Exception exception)
            {
                MessageBox.Show(exception.ToString(), "エラー");
            }
            mergeLayersAndSetPictureBox1Image(rect);
        }

        // Refresh()などでよばれる。
        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            if (penmode == PENMODE.DRAW)
            {
                return;
            }
            else if (penmode == PENMODE.LINE)
            {
                // マウスのドラッグ中の直線表示
                if (end_OTHER == false) return;
                int psize = (int)Math.Ceiling(penSize * d_zoom);
                Pen pen = new Pen(Color.FromArgb(alpha, myColor[0], myColor[1], myColor[2]),psize);
                //Pen pen = new Pen(Color.FromArgb(alpha, myColor[0], myColor[1], myColor[2]), penSize);
                e.Graphics.DrawLine(pen, startP_OTHER_REAL, endP_OTHER_REAL);
                return;
            }
            else if (penmode == PENMODE.ELLIPSE)
            {
                // マウスのドラッグ中の楕円表示
                if (end_OTHER == false) return;
                int largex = Math.Max(startP_OTHER_REAL.X, endP_OTHER_REAL.X);
                int smallx = Math.Min(startP_OTHER_REAL.X,endP_OTHER_REAL.X);
                int largey = Math.Max(startP_OTHER_REAL.Y,endP_OTHER_REAL.Y);
                int smally = Math.Min(startP_OTHER_REAL.Y,endP_OTHER_REAL.Y);
                int psize = (int)Math.Ceiling(penSize * d_zoom);
                Pen pen = new Pen(Color.FromArgb(alpha, myColor[0], myColor[1], myColor[2]), psize);
                //Pen pen = new Pen(Color.FromArgb(alpha, myColor[0], myColor[1], myColor[2]), penSize);
                e.Graphics.DrawEllipse(pen, smallx, smally, largex - smallx, largey - smally);
                return;
            }
        }

        private Point pictureBoxPointToLayerPoint(MouseEventArgs e)
        {
            Point p = new Point();
            int ex = (int)Math.Floor(e.X / d_zoom);
            int ey  = (int)Math.Floor(e.Y / d_zoom);
            if (this.nowStateOfRotate == StateOfRotate.ROTATE000)
            {
                p.X = ex;
                p.Y = ey;
                
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE090)
            {
                p.X = PageWidth - ey - 1;
                p.Y = ex;
                
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE180)
            {
                p.X = PageWidth - ex- 1;
                p.Y = PageHeight - ey - 1;
                
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE270)
            {
                p.X = ey;
                p.Y = PageHeight - ex - 1;
                
            }

            //if (p.X < 0) p.X = 0;
            //if (p.X > PageWidth) p.X = PageWidth - 1;
            //if (p.Y < 0) p.Y = 0;
            //if (p.Y > PageHeight) p.Y = PageHeight - 1;

            return p;
        }

        private Rectangle rectangleFrom2Point(Point p1, Point p2)
        {
            int largeX = Math.Max(p1.X, p2.X);
            int smallX = Math.Min(p1.X, p2.X);
            int largeY = Math.Max(p1.Y, p2.Y);
            int smallY = Math.Min(p1.Y, p2.Y);

            Rectangle rect = new Rectangle(smallX, smallY, largeX - smallX, largeY - smallY);
            return rect;
        }

        private void layer1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            targetLayer = layer1;

            // チェックの整合性をとる。
            layer_ToolStripMenuItem_CheckedRefresh();

            if (showmode == SHOWMODE.LAYERONLY)
            {
                //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
                //setPictureBox1Image(rect);
                fullSetPictureBox_so_cursor();
            }
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},1", MyMacros.TargetLayer));
        }

        private void layer2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            targetLayer = layer2;

            // チェックの整合性をとる。
            layer_ToolStripMenuItem_CheckedRefresh();

            if (showmode == SHOWMODE.LAYERONLY)
            {
                //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
                //setPictureBox1Image(rect);
                fullSetPictureBox_so_cursor();
            }
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},2", MyMacros.TargetLayer));
        }

        private void layer3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            targetLayer = layer3;

            // チェックの整合性をとる。
            layer_ToolStripMenuItem_CheckedRefresh();

            if (showmode == SHOWMODE.LAYERONLY)
            {
                //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
                //setPictureBox1Image(rect);
                fullSetPictureBox_so_cursor();
            }
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},3", MyMacros.TargetLayer));
        }

        private void layer4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            targetLayer = layer4;

            // チェックの整合性をとる。
            layer_ToolStripMenuItem_CheckedRefresh();

            if (showmode == SHOWMODE.LAYERONLY)
            {
                //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
                //setPictureBox1Image(rect);
                fullSetPictureBox_so_cursor();
            }
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},4", MyMacros.TargetLayer));
        }

        private void pen1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penSize = 1; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void pen2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penSize = 2; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void pen4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penSize = 4; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void pen8ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penSize = 8; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void pen16ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penSize = 16; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void pen32ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penSize = 32; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void bitmapCopyWithMode(Bitmap from, Bitmap to, BITMAP_COPY_MODE mode)
        {
            // こんな場合があるのかどうか
            if (from.Width == 0 || from.Height == 0 || to.Width == 0 || to.Height == 0) return;

            // 同じオブジェクトなら
            if (to.Equals(from)) return;

            // サイズが同じならモードによらず
            if (to.Size == from.Size)
            {
                for (int x = 0; x < to.Width; x++)
                {
                    for (int y = 0; y < to.Height; y++)
                    {
                        to.SetPixel(x, y, from.GetPixel(x, y));
                    }
                }
                return;
            }

            // モードで場合わけ
            if (mode == BITMAP_COPY_MODE.CENTER)
            {
                bitmapCopyCenter(from, to);
            }
            else if (mode == BITMAP_COPY_MODE.TILES)
            {
                bitmapCopyTiles(from, to);
            }
            else if (mode == BITMAP_COPY_MODE.STRETCH)
            {
                bitmapCopyStretch(from, to);
            }

            return;
        }

        private void bitmapCopyCenter(Bitmap from, Bitmap to)
        {
            for (int x = 0; x < to.Width; x++)
            {
                for (int y = 0; y < to.Height; y++)
                {
                    int ansX = from.Width/2 - to.Width/2 + x;
                    int ansY = from.Height/2 - to.Height/2 + y;
                    if (ansX < 0 || ansX > from.Width - 1 || ansY < 0 || ansY > from.Height - 1)
                    {
                        to.SetPixel(x,y,Color.FromArgb((int)MyAlpha.HIGH, transparent,transparent,transparent));
                    }
                    else
                    {
                        to.SetPixel(x, y, from.GetPixel(ansX, ansY));
                    }
                }
            }
            return;
        }

        private void bitmapCopyTiles(Bitmap from, Bitmap to)
        {
            for (int x = 0; x < to.Width; x++)
            {
                for (int y = 0; y < to.Height; y++)
                {
                    int ansX = x % from.Width;
                    int ansY = y % from.Height;
                    to.SetPixel(x, y, from.GetPixel(ansX, ansY));
                }
            }
            return;
        }

        private void bitmapCopyStretch(Bitmap from, Bitmap to)
        {
            for (int x = 0; x < to.Width; x++)
            {
                for (int y = 0; y < to.Height; y++)
                {
                    int ansX = (int)(x * ((double)from.Width / (double)to.Width));
                    if (ansX > from.Width - 1) ansX = from.Width - 1;
                    int ansY = (int)(y * ((double)from.Height / (double)to.Height));
                    if (ansY > from.Height - 1) ansY = from.Height - 1;
                    to.SetPixel(x, y, from.GetPixel(ansX, ansY));
                }
            }
            return;
        }

        private Bitmap getBitmap_OpenFileDialog()
        {
            Bitmap bmp = null;
            
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "画像ファイル(*.bmp;*.jpg;*.jpeg;*.png)|*.bmp;*.jpg;*.jpeg;*.png";
            ofd.Title = "開くファイルを選択してください";
            ofd.RestoreDirectory = true;

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                System.IO.FileStream stream = new System.IO.FileStream(ofd.FileName, System.IO.FileMode.Open);
                bmp = new Bitmap(stream);
                stream.Close();
            }

            return bmp;
        }

        private void saveLayer_SaveFileDaialog(Layer layer)
        {
            SaveFileDialog sfd = new SaveFileDialog();
            // jpegだとアルファ情報が失われるっぽい。
            //sfd.Filter = "ファイル(*.bmp;*.jpeg)|*.bmp;*jpeg";

            // System.Drawing.Imaging.ImageFormat.MemoryBmp
            // png?
            sfd.Filter = "ファイル(*.png)|*.png";
            sfd.Title = "保存先のファイルを選択してください";

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                Bitmap bmp = layer.GetBitmap();

                //if(sfd.FileName.EndsWith(".bmp"))
                //{
                //    // System.Drawing.Imaging.ImageFormat.Bmp だとアルファ値が強制255される
                //    bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.MemoryBmp);
                //}
                //else if (sfd.FileName.EndsWith(".jpeg"))
                //{
                //    bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.Jpeg);
                //}
                //else
                //{
                //    MessageBox.Show(".bmp or .jpeg");
                //}

                // System.Drawing.Imaging.ImageFormat.Bmp だとアルファ値が強制255される
                bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.MemoryBmp);
                bmp.Dispose();
            }
        }

        private void loadModeCenterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadModeCenterToolStripMenuItem.Checked = false;
            loadModeTilesToolStripMenuItem.Checked = false;
            loadModeStretchToolStripMenuItem.Checked = false;

            bitmapcopymode = BITMAP_COPY_MODE.CENTER;
            loadModeCenterToolStripMenuItem.Checked = true;
        }

        private void loadModeTilesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadModeCenterToolStripMenuItem.Checked = false;
            loadModeTilesToolStripMenuItem.Checked = false;
            loadModeStretchToolStripMenuItem.Checked = false;

            bitmapcopymode = BITMAP_COPY_MODE.TILES;
            loadModeTilesToolStripMenuItem.Checked = true;
        }

        private void loadModeStretchToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadModeCenterToolStripMenuItem.Checked = false;
            loadModeTilesToolStripMenuItem.Checked = false;
            loadModeStretchToolStripMenuItem.Checked = false;

            bitmapcopymode = BITMAP_COPY_MODE.STRETCH;
            loadModeStretchToolStripMenuItem.Checked = true;
        }

        private void loadLayer(Layer layer, BITMAP_COPY_MODE mode)
        {
            Bitmap from = getBitmap_OpenFileDialog();
            if (from == null) return;
            Bitmap to = new Bitmap(PageWidth, PageHeight, FORMAT);
            bitmapCopyWithMode(from, to, mode);
            try
            {
                layer.SetFromBitmap(to);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString(), "");
            }
            
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //mergeLayersAndSetPictureBox1Image(rect);
            meregeFullAndSetPictureBox_so_cursor();
        }

        private void loadLayer1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadLayer(layer1, bitmapcopymode);
        }

        private void loadLayer2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadLayer(layer2, bitmapcopymode);
        }

        private void loadLayer3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadLayer(layer3, bitmapcopymode);
        }

        private void loadLayer4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            loadLayer(layer4, bitmapcopymode);
        }

        private void saveMergedToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveLayer_SaveFileDaialog(layermerge);
        }

        private void saveLayer1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveLayer_SaveFileDaialog(layer1);
        }

        private void saveLayer2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveLayer_SaveFileDaialog(layer2);
        }

        private void saveLayer3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveLayer_SaveFileDaialog(layer3);
        }

        private void saveLayer4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveLayer_SaveFileDaialog(layer4);
        }

        ////////////////////////////////////////////
        private void dDMOverWriteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            dDML1OverWriteToolStripMenuItem_Click(dummy, dummyE);
            dDML2OverWriteToolStripMenuItem_Click(dummy, dummyE);
            dDML3OverWriteToolStripMenuItem_Click(dummy, dummyE);
            dDML4OverWriteToolStripMenuItem_Click(dummy, dummyE);
            dDMOverWriteToolStripMenuItem.Checked = true;
            dDMSimpleMixToolStripMenuItem.Checked = false;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},ow", MyMacros.DotDrawMode));
        }

        private void dDMSimpleMixToolStripMenuItem_Click(object sender, EventArgs e)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            dDML1SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            dDML2SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            dDML3SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            dDML4SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            dDMSimpleMixToolStripMenuItem.Checked = true;
            dDMOverWriteToolStripMenuItem.Checked = false;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},sm", MyMacros.DotDrawMode));
        }
        ////////////////////////////////////////////

        private void dDML1OverWriteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML1SimpleMixToolStripMenuItem.Checked = false;
            dDML1OverWriteToolStripMenuItem.Checked = true;
            layer1.setDotDrawMode(Layer.DotDrawMode.OVERWRITE);
        }

        private void dDML1SimpleMixToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML1OverWriteToolStripMenuItem.Checked = false;
            dDML1SimpleMixToolStripMenuItem.Checked = true;
            layer1.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
        }

        private void dDML2OverWriteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML2SimpleMixToolStripMenuItem.Checked = false;
            dDML2OverWriteToolStripMenuItem.Checked = true;
            layer2.setDotDrawMode(Layer.DotDrawMode.OVERWRITE);
        }

        private void dDML2SimpleMixToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML2OverWriteToolStripMenuItem.Checked = false;
            dDML2SimpleMixToolStripMenuItem.Checked = true;
            layer2.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
        }

        private void dDML3OverWriteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML3SimpleMixToolStripMenuItem.Checked = false;
            dDML3OverWriteToolStripMenuItem.Checked = true;
            layer3.setDotDrawMode(Layer.DotDrawMode.OVERWRITE);
        }

        private void dDML3SimpleMixToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML3OverWriteToolStripMenuItem.Checked = false;
            dDML3SimpleMixToolStripMenuItem.Checked = true;
            layer3.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
        }

        private void dDML4OverWriteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML4SimpleMixToolStripMenuItem.Checked = false;
            dDML4OverWriteToolStripMenuItem.Checked = true;
            layer4.setDotDrawMode(Layer.DotDrawMode.OVERWRITE);
        }

        private void dDML4SimpleMixToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDML4OverWriteToolStripMenuItem.Checked = false;
            dDML4SimpleMixToolStripMenuItem.Checked = true;
            layer4.setDotDrawMode(Layer.DotDrawMode.SIMPLEMIX);
        }

        // レイヤーをスワップさせたとき。など。
        private void dDML___ToosStripMenuItem_CheckedRefresh()
        {
            Layer[] layers = { layer1, layer2, layer3, layer4 };
            ToolStripMenuItem[] simplemix = {dDML1SimpleMixToolStripMenuItem,
                                                dDML2SimpleMixToolStripMenuItem,
                                                dDML3SimpleMixToolStripMenuItem,
                                                dDML4SimpleMixToolStripMenuItem};
            ToolStripMenuItem[] overwrite = {dDML1OverWriteToolStripMenuItem,
                                                dDML2OverWriteToolStripMenuItem,
                                                dDML3OverWriteToolStripMenuItem,
                                                dDML4OverWriteToolStripMenuItem};

            for (int i = 0; i < layers.Length; i++)
            {
                simplemix[i].Checked = false;
                overwrite[i].Checked = false;
                if (layers[i].getDotDrawMode() == Layer.DotDrawMode.SIMPLEMIX)
                {
                    simplemix[i].Checked = true;
                }
                else if (layers[i].getDotDrawMode() == Layer.DotDrawMode.OVERWRITE)
                {
                    overwrite[i].Checked = true;
                }
            }
        }

        private void layer_ToolStripMenuItem_CheckedRefresh()
        {
            Layer[] layers = { layer1, layer2, layer3, layer4 };
            ToolStripMenuItem[] ltsmi = {layer1ToolStripMenuItem, 
                                            layer2ToolStripMenuItem,
                                            layer3ToolStripMenuItem,
                                            layer4ToolStripMenuItem};
            for (int i = 0; i < layers.Length; i++)
            {
                ltsmi[i].Checked = false;
                if (targetLayer == layers[i])
                    ltsmi[i].Checked = true;
            }

            formTextInfo();
        }

        // ////////////////////////////////////////////////////////////////

        private void lmmSimpleMixerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            lmm_ToolStripMenuItemCheckedFalse();
            lmmSimpleMixerToolStripMenuItem.Checked = true;

            layersmergemode = LAYERS_MERGE_MODE.SIMPLEMIXER;

            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //mergeLayersAndSetPictureBox1Image(rect);
            meregeFullAndSetPictureBox_so_cursor();
        }

        private void lmmCellgaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            lmm_ToolStripMenuItemCheckedFalse();
            lmmCellgaToolStripMenuItem.Checked = true;

            layersmergemode = LAYERS_MERGE_MODE.CELLGA;

            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //mergeLayersAndSetPictureBox1Image(rect);
            meregeFullAndSetPictureBox_so_cursor();
        }

        private void lmmCellga2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            lmm_ToolStripMenuItemCheckedFalse();
            lmmCellga2ToolStripMenuItem.Checked = true;

            layersmergemode = LAYERS_MERGE_MODE.CELLGA2;
            meregeFullAndSetPictureBox_so_cursor();
        }

        private void lmm_ToolStripMenuItemCheckedFalse()
        {
            lmmSimpleMixerToolStripMenuItem.Checked = false;
            lmmCellgaToolStripMenuItem.Checked = false;
            lmmCellga2ToolStripMenuItem.Checked = false;
        }

        // ///////////////////////////////////////////////////////////////////

        private void showModeMergeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            showModeLayerOnlyToolStripMenuItem.Checked = false;
            showModeMergeToolStripMenuItem.Checked = true;
            showmode = SHOWMODE.MERGE;

            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //setPictureBox1Image(rect);
            fullSetPictureBox_so_cursor();
        }

        private void showModeLayerOnlyToolStripMenuItem_Click(object sender, EventArgs e)
        {

            showModeMergeToolStripMenuItem.Checked = false;
            showModeLayerOnlyToolStripMenuItem.Checked = true;
            showmode = SHOWMODE.LAYERONLY;

            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //setPictureBox1Image(rect);
            fullSetPictureBox_so_cursor();
        }

        private void geTthumbnailsToolStripMenuItem_Click(object sender, EventArgs e)
        {
    
            int step = 5;

            int width = PageWidth / step * 3;
            int height = PageHeight / step * 4;

            Form thumForm = new Form();
            PictureBox thumPic = new PictureBox();
            thumPic.Name = "thumPic";
            thumPic.BackColor = pictureBox1.BackColor;
            thumForm.Text = "this picturebox's backcolor = " + thumPic.BackColor.ToString();
            Bitmap thumBit = new Bitmap(width, height,FORMAT);
            Button getButton = new Button();
            Label label_step = new Label();
            label_step.Text = step.ToString();
            label_step.Name = "label_step";
            
            thumForm.Controls.Add(thumPic);
            thumForm.Controls.Add(getButton);
            thumForm.Controls.Add(label_step);

            
            thumPic.Image = thumBit;
            thumPic.Size = new Size(width, height);
            thumForm.Size = new Size(width + 50, height + 100);

            getButton.Location = new System.Drawing.Point(20, 20 + height);
            getButton.Text = "get";
            getButton.Click += new EventHandler(thumForm_getButton_Click);

            setThumnails(thumBit, step);

            thumForm.Show();
            thumPic.Invalidate();
            thumPic.Update();
        }

        void thumForm_getButton_Click(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            Form thumForm = (Form)(((Button)sender).Parent);
            Control[] controls = thumForm.Controls.Find("thumPic", true);
            PictureBox pictureBox = (PictureBox)controls[0];
            Control[] controls2 = thumForm.Controls.Find("label_step", true);
            Label label = (Label)controls2[0];
            int step = int.Parse(label.Text);

            setThumnails((Bitmap)pictureBox.Image, step);
            pictureBox.Invalidate();
            pictureBox.Update();

            Debug.WriteLine(pictureBox.BackColor.ToString());
        }

        private void setThumnails(Bitmap thumBit, int step)
        {
            Color black = Color.FromArgb(255, 0, 0,0);
            Color white = Color.FromArgb(255, 255, 255, 255);

            int startx;
            int wx = PageWidth / step;
            int starty;
            int hy = PageHeight / step;

            startx = 0;
            starty = 0;
            int layerx = 0;
            int layery = 0;
            setthumBit(startx,starty,wx,hy,layerx,layery,step,layer1,thumBit,black,0);
            startx = wx; starty = 0; 
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer1, thumBit, white,1);
            startx = wx * 2; starty = 0;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer1, thumBit, white, -1);

            startx = 0; starty = hy;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer2, thumBit, black,0);
            startx = wx; starty = hy;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer2, thumBit, white,1);
            startx = wx * 2; starty = hy;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer2, thumBit, white, -1);

            startx = 0; starty = hy * 2;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer3, thumBit, black,0);
            startx = wx; starty = hy * 2;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer3, thumBit, white,1);
            startx = wx * 2; starty = hy * 2;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer3, thumBit, white, -1);

            startx = 0; starty = hy * 3;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer4, thumBit, black,0);
            startx = wx; starty = hy * 3;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer4, thumBit, white,1);
            startx = wx * 2; starty = hy * 3;
            setthumBit(startx, starty, wx, hy, layerx, layery, step, layer4, thumBit, white, -1);

        }

        // modeは0または1またはそれ以外
        private void setthumBit(int startx,int starty,int wx, int hy, int layerx, int layery, int step,Layer layer, Bitmap thumBit, Color color,int mode)
        {
            // mode1で仕用
            Color blue = Color.FromArgb(255, 0, 0,255);
            Color white = Color.FromArgb(255, 255, 255, 255);

            int lx = layerx;

            
            for (int x = startx; x < startx + wx; x++)
            {
                int ly = layery;
                for (int y = starty; y < starty + hy; y++)
                {

                    if (layer.IsDotTransparent(lx, ly))　// 透過色の部分
                    {

                        if (mode == 0)　// 透過色の部分は渡された色（color）で
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, color);
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else if (mode == 1) // 透過色の部分は青で
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, blue);
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else // layerのデータをコピー
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, Color.FromArgb(layer.GetDotAlpha(lx, ly),
                                    layer.GetDotRed(lx, ly),
                                    layer.GetDotGreen(lx, ly),
                                    layer.GetDotBlue(lx, ly)
                                    ));
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                    }
                    else // 透過色じゃない部分
                    {
                        if (mode == 0) // layerのデータをコピー
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, Color.FromArgb(layer.GetDotAlpha(lx, ly),
                                    layer.GetDotRed(lx, ly),
                                    layer.GetDotGreen(lx, ly),
                                    layer.GetDotBlue(lx, ly)
                                    ));
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else if (mode == 1) // 透過色じゃない部分は白で
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, white);
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                        else // layerのデータをコピー
                        {
                            try
                            {
                                thumBit.SetPixel(x, y, Color.FromArgb(layer.GetDotAlpha(lx, ly),
                                    layer.GetDotRed(lx, ly),
                                    layer.GetDotGreen(lx, ly),
                                    layer.GetDotBlue(lx, ly)
                                    ));
                            }
                            catch (Exception exc)
                            {
                                MessageBox.Show(exc.ToString(), "");
                                goto LOOPEND;
                            }
                        }
                    }
                    ly += step;
                }
                lx += step;
            }
        LOOPEND: ;
        }

        private void mynSaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();

            String str = String.Format("{0}_{1}_", PageWidth, PageHeight);
            sfd.Filter = str + "MYNファイル保存(*.myn)|*.myn";
            sfd.Title = "保存先のファイルを選択してください";

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                //Bitmap bmp1 = layer1.GetBitmap();
                //Bitmap bmp2 = layer2.GetBitmap();
                //Bitmap bmp3 = layer3.GetBitmap();
                //Bitmap bmp4 = layer4.GetBitmap();
                Bitmap bmp = new Bitmap(PageWidth, PageHeight * 4, FORMAT);

                //Bitmap[] bmps = { bmp1, bmp2, bmp3, bmp4 };
                Layer[] layers = { layer1, layer2, layer3, layer4 };

                //for (int i = 0; i < bmps.Length; i++)
                for (int i= 0; i < layers.Length; i++)
                {
                    for (int x = 0; x < PageWidth; x++)
                    {
                        for (int y = 0; y < PageHeight; y++)
                        {
                            Color color = Color.FromArgb(layers[i].GetDotAlpha(x,y), 
                                layers[i].GetDotRed(x,y), 
                                layers[i].GetDotGreen(x,y), 
                                layers[i].GetDotBlue(x,y));
                            //bmp.SetPixel(x, y + i * PageHeight, bmps[i].GetPixel(x, y));
                            bmp.SetPixel(x, y + i * PageHeight, color);
                        }
                    }
                }

                bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.MemoryBmp);
                //for (int i = 0; i < bmps.Length; i++)
                //{
                //    bmps[i].Dispose();
                //}
                bmp.Dispose();
            }
        }


        private void mynLoadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Bitmap bmp = null;

            OpenFileDialog ofd = new OpenFileDialog();
            String str = String.Format("{0}_{1}_", PageWidth, PageHeight);
            // ofd.Filter = str + "MYNファイル読み込み(*.myn)|*.myn";
            ofd.Filter = "MYNファイル読み込み(*.myn)|*.myn";
            ofd.Title = "開くファイルを選択してください";
            ofd.RestoreDirectory = true;

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                System.IO.FileStream stream = new System.IO.FileStream(ofd.FileName, System.IO.FileMode.Open);
                bmp = new Bitmap(stream);
                stream.Close();

                if (bmp.Width != PageWidth || bmp.Height != PageHeight * 4)
                {
                    mynLoadDifferentSize(bmp);
                    return;
                }

                Layer[] layers = { layer1, layer2, layer3, layer4 };
                for (int i = 0; i < layers.Length; i++)
                {
                    for (int x = 0; x < PageWidth; x++)
                    {
                        for (int y = 0; y < PageHeight; y++)
                        {
                            Color c = bmp.GetPixel(x, y + i * PageHeight);
                            int[] colors = { c.R, c.G, c.B };
                            layers[i].SetDot(x, y, c.A, colors);
                        }
                    }
                }

                //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
                //mergeLayersAndSetPictureBox1Image(rect);
                meregeFullAndSetPictureBox_so_cursor();
            }

        }

        private void mynLoadDifferentSize(Bitmap bmp)
        {
            int newHeight = bmp.Height / 4;
            if (newHeight < MinWH || bmp.Width < MinWH || newHeight > MaxWH || bmp.Width > MaxWH)
            {
                int min4 = MinWH * 4;
                int max4 = MaxWH * 4;
                String s = String.Format("outOfRange ({0},{1})-({2},{3})", MinWH, min4, MaxWH, max4);
                MessageBox.Show(s, "");
                return;
            }

            String str = String.Format("({0},{1}) -> ({2},{3})。pictureBoxとlayerのサイズを変更します", PageWidth, PageHeight, bmp.Width, newHeight);
            
            DialogResult result = MessageBox.Show(str,
                "サイズが異なります",
                MessageBoxButtons.YesNoCancel,
                MessageBoxIcon.Exclamation,
                MessageBoxDefaultButton.Button2);


            if (result == DialogResult.Yes)
            {
                resizeLayersAndPictureboxAndBitmap(bmp.Width, newHeight);

                Layer[] layers = { layer1, layer2, layer3, layer4 };
                for (int i = 0; i < layers.Length; i++)
                {
                    for (int x = 0; x < PageWidth; x++)
                    {
                        for (int y = 0; y < PageHeight; y++)
                        {
                            Color c = bmp.GetPixel(x, y + i * PageHeight);
                            int[] colors = { c.R, c.G, c.B };
                            layers[i].SetDot(x, y, c.A, colors);
                        }
                    }
                }

                meregeFullAndSetPictureBox_so_cursor();
            }
            else if (result == DialogResult.No)
            {
                return;
            }
            else if (result == DialogResult.Cancel)
            {
                return;
            }
        }

        private void step200L1LToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayerLinesByStep(200, layer1);
        }

        private void step150L1LToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayerLinesByStep(150, layer1);
        }

        private void step100L1LToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayerLinesByStep(100, layer1);
        }

        private void step50L1LToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayerLinesByStep(50, layer1);
        }

        private void LayerLinesByStep(int step, Layer layer)
        {
            int x = step;
            int y = step;
            int a = 255;
            //int[] colors = colorsFromRgb((int)MyColor.BLACK);
            int[] colors = myColor;
            int width = 1;
            while (x < PageWidth)
            {
                Point start = new Point(x,0);
                Point end = new Point(x, PageHeight - 1);
                Rectangle rect = layer.DrawLine(a, colors, start, end, width,false,Layer.DrawLinePenKind.FIX_SQUARE_FILL);
                mergeLayersAndSetPictureBox1Image(rect);
                x += step;
            }

            while (y < PageHeight)
            {
                Point start = new Point(0, y);
                Point end = new Point(PageWidth - 1, y);
                Rectangle rect = layer.DrawLine(a, colors, start, end, width,false,Layer.DrawLinePenKind.FIX_SQUARE_FILL);
                mergeLayersAndSetPictureBox1Image(rect);
                y += step;
            }
        }

        private void tilesAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Layer[] layers = { layer1, layer2, layer3, layer4 };
            tileAction(layers, 100);
        }

        private void tilesLayer1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Layer[] layers = { layer1 };
            tileAction(layers, 100);
        }

        private void tilesLayer2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Layer[] layers = { layer2 };
            tileAction(layers, 100);
        }

        private void tilesLayer3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Layer[] layers = { layer3 };
            tileAction(layers, 100);
        }

        private void tilesLayer4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Layer[] layers = { layer4 };
            tileAction(layers, 100);
        }

        private void swap1and2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            swapLayers(ref layer1, ref layer2);
        }

        private void swap1and3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            swapLayers(ref layer1, ref layer3);
        }

        private void swap1and4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            swapLayers(ref layer1, ref layer4);
        }

        private void swap2and3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            swapLayers(ref layer2, ref layer3);
        }

        private void swap2and4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            swapLayers(ref layer2, ref layer4);
        }

        private void swap3and4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            swapLayers(ref layer3, ref layer4);
        }

        private void swapLayers(ref Layer layerx, ref Layer layery)
        {            
            Layer tmp = layerx;
            layerx = layery;
            layery = tmp;

            // チェックの整合性をとる。
            layer_ToolStripMenuItem_CheckedRefresh();

            // チェックの整合性をおこなう。
            dDML___ToosStripMenuItem_CheckedRefresh();
        }

        private void refresh_layermerge_ViewViewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //mergeLayersAndSetPictureBox1Image(rect);
            meregeFullAndSetPictureBox_so_cursor();
        }

        private void cPBBCColorWhiteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pictureBox1.BackColor = Color.White;
            pictureBoxPenColor.BackColor = Color.White;
        }

        private void cPBBCColorBlackToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pictureBox1.BackColor = Color.Black;
            pictureBoxPenColor.BackColor = Color.Black;
        }

        private void cPBBCColorAzureToolStripMenuItem_Click(object sender, EventArgs e)
        {
            pictureBox1.BackColor = Color.Azure;
            pictureBoxPenColor.BackColor = Color.Azure;
        }

        private void cPBBCColorTransparentToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //SetStyle(ControlStyles.SupportsTransparentBackColor, true);
            pictureBox1.BackColor = Color.Transparent; // 透明
            pictureBoxPenColor.BackColor = Color.White;
        }

        private void prtpb_Click(object sender, EventArgs e)
        {
            Bitmap bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics g = Graphics.FromImage(bmp);

            Point p = pictureBox1.PointToScreen(new Point(0,0));

            g.CopyFromScreen(p, new Point(0, 0), bmp.Size);
            
            /*
            Clipboard.SetDataObject(bmp);
            */

            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "ファイル(*.bmp)|*.bmp";
            sfd.Title = "保存先のファイルを選択してください";

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.Bmp);
                bmp.Dispose();
            }
            g.Dispose();
        }

        // //////////////////////////////////////////

        private void penMode_ToolStripMenuItem_Clicked(ToolStripMenuItem tsmi)
        {
            penMode_ToolStripMenuItem_unchek();
            tsmi.Checked = true;
            formTextInfo();
        }

        private void penModeDrawToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penmode = PENMODE.DRAW;
            penMode_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},d", MyMacros.PenMode));
        }

        private void penModeLineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penmode = PENMODE.LINE;
            penMode_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},l", MyMacros.PenMode));
        }

        private void penModeEllipseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penmode = PENMODE.ELLIPSE;
            penMode_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},e", MyMacros.PenMode));
        }


        private void penModeStampDDCToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penmode = PENMODE.STAMP_DDC;
            penMode_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},s", MyMacros.PenMode));
        }

        private void penModeCopyToClipboardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            penmode = PENMODE.COPY_TO_CLIPBOARD;
            penMode_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f", MyMacros.PenMode));
        }

        private void penMode_ToolStripMenuItem_unchek()
        {
            penModeDrawToolStripMenuItem.Checked = false;
            penModeLineToolStripMenuItem.Checked = false;
            penModeEllipseToolStripMenuItem.Checked = false;
            penModeStampDDCToolStripMenuItem.Checked = false;
            penModeCopyToClipboardToolStripMenuItem.Checked = false;
        }

        // /////////////////////////


        private void dDMSMHighToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDMSMHighToolStripMenuItem.Checked = false;
            dDMSMMiddleToolStripMenuItem.Checked = false;
            dDMSMLowToolStripMenuItem.Checked = false;
            dDMSMNoneToolStripMenuItem.Checked = false;

            dDMSMHighToolStripMenuItem.Checked = true;

            layer1.SetDDMSM_Rate(Layer.DDMSM_High);
            layer2.SetDDMSM_Rate(Layer.DDMSM_High);
            layer3.SetDDMSM_Rate(Layer.DDMSM_High);
            layer4.SetDDMSM_Rate(Layer.DDMSM_High);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},h", MyMacros.DDMSimpleMixRate));
        }

        private void dDMSMMiddleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDMSMHighToolStripMenuItem.Checked = false;
            dDMSMMiddleToolStripMenuItem.Checked = false;
            dDMSMLowToolStripMenuItem.Checked = false;
            dDMSMNoneToolStripMenuItem.Checked = false;

            dDMSMMiddleToolStripMenuItem.Checked = true;

            layer1.SetDDMSM_Rate(Layer.DDMSM_Middle);
            layer2.SetDDMSM_Rate(Layer.DDMSM_Middle);
            layer3.SetDDMSM_Rate(Layer.DDMSM_Middle);
            layer4.SetDDMSM_Rate(Layer.DDMSM_Middle);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},m", MyMacros.DDMSimpleMixRate));
        }

        private void dDMSMLowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDMSMHighToolStripMenuItem.Checked = false;
            dDMSMMiddleToolStripMenuItem.Checked = false;
            dDMSMLowToolStripMenuItem.Checked = false;
            dDMSMNoneToolStripMenuItem.Checked = false;

            dDMSMLowToolStripMenuItem.Checked = true;

            layer1.SetDDMSM_Rate(Layer.DDMSM_Low);
            layer2.SetDDMSM_Rate(Layer.DDMSM_Low);
            layer3.SetDDMSM_Rate(Layer.DDMSM_Low);
            layer4.SetDDMSM_Rate(Layer.DDMSM_Low);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},l", MyMacros.DDMSimpleMixRate));
        }

        private void dDMSMNoneToolStripMenuItem_Click(object sender, EventArgs e)
        {
            dDMSMHighToolStripMenuItem.Checked = false;
            dDMSMMiddleToolStripMenuItem.Checked = false;
            dDMSMLowToolStripMenuItem.Checked = false;
            dDMSMNoneToolStripMenuItem.Checked = false;

            dDMSMNoneToolStripMenuItem.Checked = true;

            layer1.SetDDMSM_Rate(Layer.DDMSM_None);
            layer2.SetDDMSM_Rate(Layer.DDMSM_None);
            layer3.SetDDMSM_Rate(Layer.DDMSM_None);
            layer4.SetDDMSM_Rate(Layer.DDMSM_None);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},n", MyMacros.DDMSimpleMixRate));
        }

        // ////////////////////


        private void randomEllipsesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Random rnd = new Random(seedForRandom += seedStep);
            

            int times = 5;
            for (int i = 0; i < times; i++)
            {
                int x1 = rnd.Next(PageWidth);
                int x2 = rnd.Next(PageWidth);
                int y1 = rnd.Next(PageHeight);
                int y2 = rnd.Next(PageHeight);
                int bias = 50;
                Point p1 = new Point(Math.Min(x1,x2) - bias, Math.Min(y1,y2) - bias);
                Point p2 = new Point(Math.Max(x1,x2) + bias ,Math.Max(y1,y2) + bias);
                rndLayer();
                rndPensize();
                targetLayer.DrawEllipse(GetRandomAlpha(2), GetRandomColors(2), p1, p2, penSize, layerdrawlinepenkind);
            }

            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //mergeLayersAndSetPictureBox1Image(rect);
            meregeFullAndSetPictureBox_so_cursor();
        }

        // ///////////////////////////////////////////////////////////////////

        private void lDLPK_ToolStripMenuItem_Clicked(ToolStripMenuItem tsmi)
        {
            lDLPK___ToolStripMenuItem_CheckedFalse();
            tsmi.Checked = true;
            formTextInfo();
        }

        private void lDLPKFIXSQUAREFILLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.FIX_SQUARE_FILL;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f2", MyMacros.PenKind));
        }

        private void lDLPKUNFIXRECTANGLEFILLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.UNFIX_RECTANGLE_FILL;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f3", MyMacros.PenKind));
        }

        private void lDLPKCIRCLEFILLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.CIRCLE_FILL;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f4", MyMacros.PenKind));
        }

        private void lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.FUNNY_BUG_UNFIX_RECTANGLE_FILL;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f5", MyMacros.PenKind));
        }

        private void lDLPK___ToolStripMenuItem_CheckedFalse()
        {
            lDLPKFIXSQUAREFILLToolStripMenuItem.Checked = false;
            lDLPKUNFIXRECTANGLEFILLToolStripMenuItem.Checked = false;
            lDLPKCIRCLEFILLToolStripMenuItem.Checked = false;
            lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem.Checked = false;
            lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem.Checked = false;
            lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem.Checked = false;
            lDLPKCIRCLERANDOMDOTToolStripMenuItem.Checked = false;
            lDLPKCRDCONCToolStripMenuItem.Checked = false;
            lDLPKCRDMIDToolStripMenuItem.Checked = false;
            lDLPKCRDSPARSEToolStripMenuItem.Checked = false;
            lDLPKUSERPENKINDToolStripMenuItem.Checked = false;
            lDLPKUPKMETHOD1ToolStripMenuItem.Checked = false;
            lDLPKUPKMETHOD2ToolStripMenuItem.Checked = false;
        }

        private void lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.FUNNY_BUG2_UNFIX_RECTANGLE_FILL;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f6", MyMacros.PenKind));
        }

        private void lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.FUNNY_BUG2B_UNFIX_RECTANGLE_FILL;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f7", MyMacros.PenKind));
        }

        private void lDLPKCRDCONCToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            layerdrawlinepenkind = Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_CONC;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            lDLPKCIRCLERANDOMDOTToolStripMenuItem.Checked = true;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f8", MyMacros.PenKind));
        }

        private void lDLPKCRDMIDToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_MID;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            lDLPKCIRCLERANDOMDOTToolStripMenuItem.Checked = true;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f9", MyMacros.PenKind));
        }

        private void lDLPKCRDSPARSEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            layerdrawlinepenkind = Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_SPARSE;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            lDLPKCIRCLERANDOMDOTToolStripMenuItem.Checked = true;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f10", MyMacros.PenKind));
        }

        private void lDLPKUPKMETHOD1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.USER_PEN_KIND_METHOD1;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            lDLPKUSERPENKINDToolStripMenuItem.Checked = true;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f11", MyMacros.PenKind));
        }

        private void lDLPKUPKMETHOD2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            layerdrawlinepenkind = Layer.DrawLinePenKind.USER_PEN_KIND_METHOD2;
            lDLPK_ToolStripMenuItem_Clicked((ToolStripMenuItem)sender);
            lDLPKUSERPENKINDToolStripMenuItem.Checked = true;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},f12", MyMacros.PenKind));
        }

        // ///////////////////////////////////////////////////////////////////////////

        private void Memory_Click(object sender, EventArgs e)
        {

            String str = "";
            Bitmap memBit;


            if (targetLayer == layer1)
            {
                str = "Layer1 ";
                memBit = layer1.GetBitmap();
            }
            else if (targetLayer == layer2)
            {
                str = "Layer2 ";
                memBit = layer2.GetBitmap();
            }
            else if (targetLayer == layer3)
            {
                str = "Layer3 ";
                memBit = layer3.GetBitmap();
            }
            else if (targetLayer == layer4)
            {
                str = "Layer4 ";
                memBit = layer4.GetBitmap();
            }
            else
            {
                return;
            }

            
            String time = DateTime.Now.ToString("yyyy-MM-dd-HH-mm-ss");
            Debug.WriteLine(time);
            str += time;

            Form memoryForm = new Form();

            // 保存取り出し用
            PictureBox memPic = new PictureBox();
            memPic.Name = "memPic";
            memPic.Image = memBit;
            memPic.Size = new Size(0, 0);


            int step = 2;
            PictureBox thumnailPic = new PictureBox();
            thumnailPic.BackColor = pictureBox1.BackColor;
            str += " backcolor = " + thumnailPic.BackColor.ToString();
            memoryForm.Text = str;
            thumnailPic.Size = new Size(PageWidth / step, PageHeight / step);

            
            Bitmap thumnailBit = new Bitmap(PageWidth / step, PageHeight / step, FORMAT);
            thumnailPic.Image = thumnailBit;
            for (int x = 0; x < thumnailBit.Width; x++)
            {
                for (int y = 0; y < thumnailBit.Height; y++)
                {
                    thumnailBit.SetPixel(x, y, memBit.GetPixel(x * step, y * step));
                }
            }

            Button restoreToLayer1 = new Button();
            Button restoreToLayer2 = new Button();
            Button restoreToLayer3 = new Button();
            Button restoreToLayer4 = new Button();
            restoreToLayer1.Size = new Size(200, restoreToLayer1.Size.Height);
            restoreToLayer2.Size = new Size(200, restoreToLayer2.Size.Height);
            restoreToLayer3.Size = new Size(200, restoreToLayer3.Size.Height);
            restoreToLayer4.Size = new Size(200, restoreToLayer4.Size.Height);
            restoreToLayer1.Text = "restoreToLayer1";
            restoreToLayer2.Text = "restoreToLayer2";
            restoreToLayer3.Text = "restoreToLayer3";
            restoreToLayer4.Text = "restoreToLayer4";
            restoreToLayer1.Location = new System.Drawing.Point(20, thumnailPic.Bottom + 10);
            restoreToLayer2.Location = new System.Drawing.Point(20, restoreToLayer1.Bottom + 10);
            restoreToLayer3.Location = new System.Drawing.Point(20, restoreToLayer2.Bottom + 10);
            restoreToLayer4.Location = new System.Drawing.Point(20, restoreToLayer3.Bottom + 10);
            restoreToLayer1.Click += new EventHandler(restoreToLayer1_Click);
            restoreToLayer2.Click += new EventHandler(restoreToLayer2_Click);
            restoreToLayer3.Click += new EventHandler(restoreToLayer3_Click);
            restoreToLayer4.Click += new EventHandler(restoreToLayer4_Click);
            memoryForm.Size = new Size(thumnailPic.Right + 15, restoreToLayer4.Bottom + 35);


            memoryForm.Controls.Add(memPic);
            memoryForm.Controls.Add(thumnailPic);
            memoryForm.Controls.Add(restoreToLayer1);
            memoryForm.Controls.Add(restoreToLayer2);
            memoryForm.Controls.Add(restoreToLayer3);
            memoryForm.Controls.Add(restoreToLayer4);

            memoryForm.Show();
            thumnailPic.Invalidate();
            thumnailPic.Update();

        }

        void restoreToLayer1_Click(object sender, EventArgs e)
        {
            restoreToLayer(sender, e, layer1);
        }

        void restoreToLayer2_Click(object sender, EventArgs e)
        {
            restoreToLayer(sender, e, layer2);
        }

        void restoreToLayer3_Click(object sender, EventArgs e)
        {
            restoreToLayer(sender, e, layer3);
        }

        void restoreToLayer4_Click(object sender, EventArgs e)
        {
            restoreToLayer(sender, e, layer4);
        }

        void restoreToLayer(object sender, EventArgs e, Layer layer)
        {
            Form memoryForm = (Form)(((Button)sender).Parent);
            Control[] controls = memoryForm.Controls.Find("memPic", true);
            PictureBox memPic = (PictureBox)controls[0];
            Bitmap memBit = (Bitmap)memPic.Image;
            try
            {
                layer.SetFromBitmap(memBit);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString(), "");
            }
        }

        private void mergeLayerLayerToLayer(Layer from1, Layer from2, Layer to)
        {
            int[] transparentTmp = {0,0,0};

            Layer[] layers = { from1, from2 };
            for (int x = 0; x < PageWidth; x++)
            {
                for (int y = 0; y < PageHeight; y++)
                {
                    int[] argb = getMixedArgbFromLayerDots(layers, x, y);
                    int[] tmpcolors = { argb[1], argb[2], argb[3] };
                    to.SetDot(x, y, argb[0], tmpcolors);
                }
            }
        }

        private void mergeLayer1and2To3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            mergeLayerLayerToLayer(layer1, layer2, layer3);
        }

        private void fillLayer1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fillLayer(layer1);
        }

        private void fillLayer2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fillLayer(layer2);
        }

        private void fillLayer3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fillLayer(layer3);
        }

        private void fillLayer4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fillLayer(layer4);
        }

        private void fillLayer(Layer layer)
        {
            Rectangle rect = new Rectangle(0, 0, PageWidth,PageHeight);
            layer.FillRectangle(alpha, myColor, rect);
        }

        private void refreshLMV_Click(object sender, EventArgs e)
        {
            //Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            //mergeLayersAndSetPictureBox1Image(rect);
            meregeFullAndSetPictureBox_so_cursor(); 
        }

        private void meregeFullAndSetPictureBox_so_cursor()
        {
            // 元のカーソルを保持
            Cursor preCursor = Cursor.Current;
            // カーソルを待機カーソルに変更
            Cursor.Current = Cursors.WaitCursor;

            Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            mergeLayersAndSetPictureBox1Image(rect);  

            // カーソルを元に戻す
            Cursor.Current = preCursor;

            zoomChanged();
        }

        private void fullSetPictureBox_so_cursor()
        {
            // 元のカーソルを保持
            Cursor preCursor = Cursor.Current;
            // カーソルを待機カーソルに変更
            Cursor.Current = Cursors.WaitCursor;

            Rectangle rect = new Rectangle(0, 0, PageWidth, PageHeight);
            setPictureBox1Image(rect);

            // カーソルを元に戻す
            Cursor.Current = preCursor;

            zoomChanged();
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            object dummy = new object();
            EventArgs dummyE  = new EventArgs();
            switch (e.KeyCode)
            {
                case Keys.W:
                    wHITEToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.T:
                    tRANSToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.R:
                    rEDToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.G:
                    gREENToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.B:
                    bLUEToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.C:
                    cYANToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.M:
                    mAGENTAToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.Y:
                    yELLOWToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D1:
                    hToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D2:
                    hMToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D3:
                    mToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D4:
                    mLToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D5:
                    lToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D6:
                    pen2ToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D7:
                    pen4ToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D8:
                    pen8ToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D9:
                    pen16ToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D0:
                    pen32ToolStripMenuItem_Click(dummy, dummyE);
                    e.Handled = true;
                    break;
                case Keys.D:
                    penModeDrawToolStripMenuItem_Click(penModeDrawToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.L:
                    penModeLineToolStripMenuItem_Click(penModeLineToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.E:
                    penModeEllipseToolStripMenuItem_Click(penModeEllipseToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.S:
                    penModeStampDDCToolStripMenuItem_Click(penModeStampDDCToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F:
                    penModeCopyToClipboardToolStripMenuItem_Click(penModeCopyToClipboardToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F2:
                    lDLPKFIXSQUAREFILLToolStripMenuItem_Click(lDLPKFIXSQUAREFILLToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F3:
                    lDLPKUNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKUNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F4:
                    lDLPKCIRCLEFILLToolStripMenuItem_Click(lDLPKCIRCLEFILLToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F5:
                    lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F6:
                    lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F7:
                    lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F8:
                    lDLPKCRDCONCToolStripMenuItem_Click(lDLPKCRDCONCToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F9:
                    lDLPKCRDMIDToolStripMenuItem_Click(lDLPKCRDMIDToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F10:
                    lDLPKCRDSPARSEToolStripMenuItem_Click(lDLPKCRDSPARSEToolStripMenuItem, dummyE);
                    e.Handled = true;
                    break;
                case Keys.F11:
                    lDLPKUPKMETHOD1ToolStripMenuItem_Click(lDLPKUPKMETHOD1ToolStripMenuItem, dummyE);
                    break;
                case Keys.F12:
                    lDLPKUPKMETHOD2ToolStripMenuItem_Click(lDLPKUPKMETHOD2ToolStripMenuItem, dummyE);
                    break;
                case Keys.Q:
                    macro1();
                    e.Handled = true;
                    break;
                case Keys.A:
                    macro2();
                    e.Handled = true;
                    break;
                case Keys.Z:
                    macro3();
                    e.Handled = true;
                    break;
                case Keys.X:
                    macro4();
                    e.Handled = true;
                    break;
                case Keys.V:
                    setFromClipBoard();
                    e.Handled = true;
                    break;
                case Keys.Space:
                    if (key_space == true)
                    {
                        key_space = false;
                        System.Drawing.Point sp = System.Windows.Forms.Cursor.Position;
                        //System.Drawing.Point cp = this.PointToClient(sp);
                        // MessageBox.Show(cp.X.ToString());
                        Object o = new Object();
                        //MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, cp.X - pictureBox1.Left, cp.Y - pictureBox1.Top, 0);
                        MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, pictureBox1.PointToClient(sp).X, pictureBox1.PointToClient(sp).Y, 0);
                        pictureBox1_MouseUp(o, mea);
                    }
                    e.Handled = true;
                    break;
                case Keys.Right:
                    keyarrowx = 0;
                    e.Handled = true;
                    break;
                case Keys.Left:
                    keyarrowx = 0;
                    e.Handled = true;
                    break;
                case Keys.Down:
                    keyarrowy = 0;
                    e.Handled = true;
                    break;
                case Keys.Up:
                    keyarrowy = 0;
                    e.Handled = true;
                    break;
                default:
                    e.Handled = true;
                    break;
            }

            formTextInfo();
        }

        private void colorPaletteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ColorPalette cp = new ColorPalette();
            cp.CpEvent += new CpEventDelegate(getColorPaletteDataAndSet);
            cp.Show();
        }

        private void getColorPaletteDataAndSet(object sender, System.EventArgs e)
        {
            ColorPalette cp = (ColorPalette)sender;
            Color color = cp.getCpColor();
            alpha = color.A;
            int rgb = color.R * 0x10000 + color.G* 0x100 + color.B;
            setColorsFromRgb(myColor, rgb);
        }

        private void pictureBoxPenColor_Click(object sender, EventArgs e)
        {
            colorPaletteToolStripMenuItem_Click(sender, e);
        }

        private void formTextInfo()
        {
            String strLayer = "?";

            if (targetLayer == layer1)
            {
                strLayer = "1";
            }
            else if (targetLayer == layer2)
            {
                strLayer = "2";
            }
            else if (targetLayer == layer3)
            {
                strLayer = "3";
            }
            else if (targetLayer == layer4)
            {
                strLayer = "4";
            }

            String strPensize = penSize.ToString();
            
            String strPenMode = "?";
            if (penModeDrawToolStripMenuItem.Checked == true)
            {
                strPenMode = "PenModeDraw";
            }
            else if (penModeLineToolStripMenuItem.Checked == true)
            {
                strPenMode = "PenModeLine";
            }
            else if (penModeEllipseToolStripMenuItem.Checked == true)
            {
                strPenMode = "PenModeEllipse";
            }
            else if (penModeStampDDCToolStripMenuItem.Checked == true)
            {
                strPenMode = "PenModeStampDDC";
            }
            else if (penModeCopyToClipboardToolStripMenuItem.Checked == true)
            {
                strPenMode = "penModeCopyToClipboard";
            }

            String strLayerDrawLinePenKind = "?";
            setStrLayerDrawLinePenKind(ref strLayerDrawLinePenKind);


            String str = " Layer" + strLayer + ", PenSize" + strPensize + ", " + strPenMode + ", " + strLayerDrawLinePenKind;
            this.Text = "MYN " + str;

        }

        private void setStrLayerDrawLinePenKind(ref string str)
        {
            if (lDLPKFIXSQUAREFILLToolStripMenuItem.Checked == true)
                str = lDLPKFIXSQUAREFILLToolStripMenuItem.Text;
            else if (lDLPKUNFIXRECTANGLEFILLToolStripMenuItem.Checked == true)
                str = lDLPKUNFIXRECTANGLEFILLToolStripMenuItem.Text;
            else if (lDLPKCIRCLEFILLToolStripMenuItem.Checked == true)
                str = lDLPKCIRCLEFILLToolStripMenuItem.Text;
            else if (lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem.Checked == true)
                str = lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem.Text;
            else if (lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem.Checked == true)
                str = lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem.Text;
            else if (lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem.Checked == true)
                str = lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem.Text;
            //else if (lDLPKCIRCLERANDOMDOTToolStripMenuItem.Checked == true)
            //    str = lDLPKCIRCLERANDOMDOTToolStripMenuItem.Text;
            else if (lDLPKCRDCONCToolStripMenuItem.Checked == true)
                str = lDLPKCRDCONCToolStripMenuItem.Text;
            else if (lDLPKCRDMIDToolStripMenuItem.Checked == true)
                str = lDLPKCRDMIDToolStripMenuItem.Text;
            else if (lDLPKCRDSPARSEToolStripMenuItem.Checked == true)
                str = lDLPKCRDSPARSEToolStripMenuItem.Text;
            else if (lDLPKUPKMETHOD1ToolStripMenuItem.Checked == true)
                str = lDLPKUPKMETHOD1ToolStripMenuItem.Text;
            else if (lDLPKUPKMETHOD2ToolStripMenuItem.Checked == true)
                str = lDLPKUPKMETHOD2ToolStripMenuItem.Text;
        }

        private void setLayersDotDrawCycleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            EditDotDrawCycle eddm = new EditDotDrawCycle();
            eddm.EddmEvent += new EddmEventDelegate(getEditDotDrawModeInfo);
            eddm.Show();
        }

        private void getEditDotDrawModeInfo(object sender, DotDrawCycle ddc, string layerstring)
        {
            Layer layer;
            if (layerstring == "layer1")
                layer = layer1;
            else if (layerstring == "layer2")
                layer = layer2;
            else if (layerstring == "layer3")
                layer = layer3;
            else if (layerstring == "layer4")
                layer = layer4;
            else
                return;

            layer.SetLayerDotDrawCycle(ddc);
        }

        // ////////////////////////////

        // 使わないか？
        private void ResizeableFalse()
        {
            Resizeable = false;
            buttonResize.Enabled = false;
        }

        private void setLabelSizeInfo()
        {
            labelSizeInfo.Text = String.Format("({0},{1})", PageWidth, PageHeight);
        }

        private void buttonResize_Click(object sender, EventArgs e)
        {
            ResizeEtc resizeEtc = new ResizeEtc(MinWH,MaxWH);
            resizeEtc.ResizeEtcEvent += new ResizeEtcEventDelegate(getResizeEtcDataAndSet);
            resizeEtc.Show();
        }

        private void getResizeEtcDataAndSet(object sender, System.EventArgs e, int newWidth, int newHeight)
        {
            resizeLayersAndPictureboxAndBitmap(newWidth, newHeight);

            //{
            //    int w = Math.Min(this.Width, newWidth + 300);
            //    int h = Math.Min(this.Height, newHeight + 150);
            //    this.Width = w;
            //    this.Height = h;
            //}

            Rectangle rect = new Rectangle(0, 0, newWidth, newHeight);
            mergeLayersAndSetPictureBox1Image(rect);
            zoomChanged();

            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1},{2}", MyMacros.Size, newWidth, newHeight));
        }

        private void resizeLayersAndPictureboxAndBitmap(int newWidth, int newHeight)
        {
            layer1.Resize(newWidth, newHeight);
            layer2.Resize(newWidth, newHeight);
            layer3.Resize(newWidth, newHeight);
            layer4.Resize(newWidth, newHeight);
            layermerge.Resize(newWidth, newHeight);

            laster_a = new Bitmap(newWidth, newHeight, FORMAT);
            laster_b = new Bitmap(newHeight, newWidth, FORMAT);

            switch (nowStateOfRotate)
            {
                case StateOfRotate.ROTATE000:
                case StateOfRotate.ROTATE180:
                    pictureBox1.Size = new Size(newWidth, newHeight);
                    pictureBox1.Image = laster_a;
                    break;
                case StateOfRotate.ROTATE090:
                case StateOfRotate.ROTATE270:
                    pictureBox1.Size = new Size(newHeight, newWidth);
                    pictureBox1.Image = laster_b;
                    break;
                default:
                    break;
            }

            PageWidth = newWidth;
            PageHeight = newHeight;
            setLabelSizeInfo();
        }


        // //////////////////////////////////////////////////////////////////

        private void fO100ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Opacity = 1.0;
        }

        private void fC90ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Opacity = 0.9;
        }

        private void fC70ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Opacity = 0.7;
        }

        private void fC50ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Opacity = 0.5;
        }

        private void fO30ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Opacity = 0.3;
        }

        private void fO10ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Opacity = 0.1;
        }

        // //////////////////////////////////////////////////

        private void fWAcceptToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Color trans = Color.FromArgb(255, transparent, transparent, transparent);
            Bitmap bmp = new Bitmap(this.Width, this.Height, FORMAT);
            for (int x = 0; x < bmp.Width - 1; x++)
                for (int y = 0; y < bmp.Height - 1; y++)
                    bmp.SetPixel(x, y, Color.Wheat);
            for (int x = pictureBox1.Left; x < pictureBox1.Left + pictureBox1.Width - 1; x++)
                for (int y = pictureBox1.Top; y < pictureBox1.Top + pictureBox1.Height - 1; y++)
                    bmp.SetPixel(x, y, trans);
            bmp.MakeTransparent(trans);
            this.TransparencyKey = trans;
            this.BackColor = trans;
            this.BackgroundImage = bmp;

            pictureBox1.BackColor = Color.FromArgb(0, transparent, transparent, transparent);

        }



        protected override Point ScrollToControl(Control activeControl)
        {
            return this.AutoScrollPosition;
        }

        private void checkBoxAntialiasing_Click(object sender, EventArgs e)
        {
            bool b = checkBoxAntialiasing.Checked;
            layer1.antiAliasing = layer2.antiAliasing = layer3.antiAliasing = layer4.antiAliasing = b;

            if(b)
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},true", MyMacros.AntiAliasing));
            else
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},false", MyMacros.AntiAliasing));
        }

        private void comboBoxAat_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBoxAat.SelectedIndex == 0)
            {
                layer1.setAntiAliasingType(Layer.AntiAliasingType.AAT1);
                layer2.setAntiAliasingType(Layer.AntiAliasingType.AAT1);
                layer3.setAntiAliasingType(Layer.AntiAliasingType.AAT1);
                layer4.setAntiAliasingType(Layer.AntiAliasingType.AAT1);
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},1", MyMacros.AntiAliasingType));
            }
            else if (comboBoxAat.SelectedIndex == 1)
            {
                layer1.setAntiAliasingType(Layer.AntiAliasingType.AAT2);
                layer2.setAntiAliasingType(Layer.AntiAliasingType.AAT2);
                layer3.setAntiAliasingType(Layer.AntiAliasingType.AAT2);
                layer4.setAntiAliasingType(Layer.AntiAliasingType.AAT2);
                mymacros.invokeWatchMyMacrosEvent(string.Format("{0},2", MyMacros.AntiAliasingType));
            }
        }

        /////////////////////////////////////////////////////////////

        private void macro1()
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            //dDML1OverWriteToolStripMenuItem_Click(dummy, dummyE);
            //dDML2OverWriteToolStripMenuItem_Click(dummy, dummyE);
            //dDML3OverWriteToolStripMenuItem_Click(dummy, dummyE);
            //dDML4OverWriteToolStripMenuItem_Click(dummy, dummyE);
            dDMOverWriteToolStripMenuItem_Click(dummy, dummyE);
        }

        private void macro2()
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            //dDML1SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            //dDML2SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            //dDML3SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            //dDML4SimpleMixToolStripMenuItem_Click(dummy, dummyE);
            dDMSimpleMixToolStripMenuItem_Click(dummy, dummyE);
        }

        private void macro3()
        {
            penSize = penSize - 1;
            if (penSize < minPenSize) penSize = minPenSize;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void macro4()
        {
            penSize = penSize + 1;
            if (penSize > maxPenSize) penSize = maxPenSize;
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));
        }

        private void macro5()
        {
        }

        private void macro6()
        {
        }



        /////////////////////////////////////////


        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

            switch (e.KeyCode)
            {
                case Keys.Space:
                    if (key_space == false)
                    {
                        key_space = true;
                        System.Drawing.Point sp = System.Windows.Forms.Cursor.Position;
                        //System.Drawing.Point cp = this.PointToClient(sp);

                        Object o = new Object();
                        //MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, cp.X - pictureBox1.Left, cp.Y - pictureBox1.Top, 0);
                        MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, pictureBox1.PointToClient(sp).X, pictureBox1.PointToClient(sp).Y, 0);
                        pictureBox1_MouseDown(o, mea);
                    }
                    e.Handled = true;
                    break;
                
                //////////////
                case Keys.Right:
                    keyarrowx = 1;
                    e.Handled = true;
                    break;
                case Keys.Left:
                    keyarrowx = -1;
                    e.Handled = true;
                    break;
                case Keys.Down:
                    keyarrowy = 1;
                    e.Handled = true;
                    break;
                case Keys.Up:
                    keyarrowy = -1;
                    e.Handled = true;
                    break;
    
                /////////////
                default:
                    e.Handled = true;
                    break;
            }

            if (checkBoxArrowKeys.Checked)
            {
                moveMouseCursor(keyarrowx, keyarrowy);
            }

        }

        private void moveMouseCursor(int x, int y)
        {
            System.Drawing.Point before = System.Windows.Forms.Cursor.Position;
            System.Drawing.Point after = new System.Drawing.Point(before.X + x, before.Y + y);
            System.Windows.Forms.Cursor.Position = after;
        }



        /////////////////////////////////////////


        private void setFromClipBoard()
        {
            string str = "";
            if (Clipboard.ContainsText())
            {
                str = Clipboard.GetText();
                setFromText(str);
            }
            else
            {
                return;
            }
        }

        private void setFromText(string str)
        {
            char[] separator = {','};
            string[] nums = str.Split(separator);
            int x, y, a, r, g, b;
            try
            {
                x = int.Parse(nums[0]);
                y = int.Parse(nums[1]);
                a = int.Parse(nums[2]);
                r = int.Parse(nums[3]);
                g = int.Parse(nums[4]);
                b = int.Parse(nums[5]);
                {
                    Point lp = new Point(x, y);
                    Point pbp = layerPointToPictureBoxPoint(lp);
                    System.Drawing.Point p = pictureBox1.PointToScreen(pbp);
                    System.Windows.Forms.Cursor.Position = p;
                }
                {
                    alpha = a;
                    int rgb = r * 0x10000 + g * 0x100 + b;
                    setColorsFromRgb(myColor, rgb);

                }
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.ToString());
            }
        }

        private Point layerPointToPictureBoxPoint(Point lp)
        {
            Point p = new Point();
            if (this.nowStateOfRotate == StateOfRotate.ROTATE000)
            {
                p.X = lp.X;
                p.Y = lp.Y;

            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE090)
            {
                p.X = lp.Y;
                p.Y = PageWidth - lp.X - 1;

            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE180)
            {
                p.X = PageWidth - lp.X - 1;
                p.Y = PageHeight - lp.Y - 1;

            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE270)
            {
                p.X = PageHeight - lp.Y - 1;
                p.Y = lp.X;
            }

            {
                p.X = (int)(p.X * d_zoom);
                p.Y = (int)(p.Y * d_zoom);
            }
            return p;
        }

        private void buttonSetFromClipboard_Click(object sender, EventArgs e)
        {
            setFromClipBoard();
        }

        
        /// <summary>
        /// ///////////////////
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void macrosWatchAsCommandToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MacrosWatchAsCommand mwac = new MacrosWatchAsCommand(this.mymacros);
            mymacros.WatchMyMacrosEvent += new WatchMyMacrosEventDelegate(mwac.watchMyMacros);
            mwac.Show();
        }

        private void macrosCommandToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MacrosCommand mc = new MacrosCommand(this.mymacros, this.mymacros.getB_MakeApng(), this.mymacros.getI_Apngstep());
            mymacros.ConvertChangedEvent += new ConvertChangedEventDelegate(mc.convertChanged);
            mymacros.invokeConvertChangedEvent();
            mymacros.B_MakeApngChangedEvent += new B_MakeApngChangedEventDelegate(mc.B_MakeApngChanged);
            mymacros.I_ApngstepChangedEvent += new I_ApngstepChangedEventDelegate(mc.I_ApngstepChanged);
            mymacros.MacrosCommandEnabledEvent += new MacrosCommandEnabledEventDelegate(mc.macrosCommandEnabled);
            mc.Show();
        }

        public Size macrosGetSize()
        {
            //return pictureBox1.Size;
            return new Size(this.PageWidth, this.PageHeight);
        }

        public void macrosSetSize(int width, int height)
        {
            if (width < Form1.MinWH)
                throw new Exception("min error");
            if (height < Form1.MinWH)
                throw new Exception("min error");
            if (width > Form1.MaxWH)
                throw new Exception("max error");
            if (height > Form1.MaxWH)
                throw new Exception("max error");

            object o = new object();
            EventArgs e = new EventArgs();
            getResizeEtcDataAndSet(o, e, width, height);
        }

        public int[] macrosGetColor()
        {
            int[] argb = new int[4];
            argb[0] = this.alpha;
            argb[1] = myColor[0];
            argb[2] = myColor[1];
            argb[3] = myColor[2];

            return argb;
        }

        public void macrosSetColor(int a, int r, int g, int b)
        {
            {
                if (a < 0 || a > 255)
                    throw new Exception("a error");
                if (r < 0 || r > 255)
                    throw new Exception("r error");
                if (g < 0 || g > 255)
                    throw new Exception("g error");
                if (b < 0 || b > 255)
                    throw new Exception("b error");
            }

            alpha = a;
            int rgb = r * 0x10000 + g * 0x100 + b;
            setColorsFromRgb(myColor, rgb);
        }

        public int macrosGetPenSize()
        {
            return penSize;
        }

        public void macrosSetPenSize(int newSize)
        {
            if (newSize < minPenSize)
                throw new Exception("minPenSize error");
            if (newSize > maxPenSize)
                throw new Exception("maxPensize error");

            penSize = newSize; formTextInfo();
            mymacros.invokeWatchMyMacrosEvent(string.Format("{0},{1}", MyMacros.PenSize, penSize));

        }

        public string macrosGetPenMode()
        {
            string s = "";

            switch (penmode)
            {
                case PENMODE.DRAW:
                    s = "d";
                    break;
                case PENMODE.LINE:
                    s = "l";
                    break;
                case PENMODE.ELLIPSE:
                    s = "e";
                    break;
                case PENMODE.STAMP_DDC:
                    s = "s";
                    break;
                case PENMODE.COPY_TO_CLIPBOARD:
                    s = "f";
                    break;
                default:
                    break;
            }

            return s;
        }

        public void macrosSetPenMode(string s)
        {
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "d":
                    penModeDrawToolStripMenuItem_Click(penModeDrawToolStripMenuItem, dummyE);
                    break;
                case "l":
                    penModeLineToolStripMenuItem_Click(penModeLineToolStripMenuItem, dummyE);
                    break;
                case "e":
                    penModeEllipseToolStripMenuItem_Click(penModeEllipseToolStripMenuItem, dummyE);
                    break;
                case "s":
                    penModeStampDDCToolStripMenuItem_Click(penModeStampDDCToolStripMenuItem, dummyE);
                    break;
                case "f":
                    penModeCopyToClipboardToolStripMenuItem_Click(penModeCopyToClipboardToolStripMenuItem, dummyE);
                    break;
                default:
                    throw new Exception("penmode not found");
                    break;
            }
        }

        public string macrosGetPenKind()
        {
            string s = "";
            switch (layerdrawlinepenkind)
            {
                case Layer.DrawLinePenKind.FIX_SQUARE_FILL:
                    s = "f2"; break;
                case Layer.DrawLinePenKind.UNFIX_RECTANGLE_FILL:
                    s = "f3"; break;
                case Layer.DrawLinePenKind.CIRCLE_FILL:
                    s = "f4"; break;
                case Layer.DrawLinePenKind.FUNNY_BUG_UNFIX_RECTANGLE_FILL:
                    s = "f5"; break;
                case Layer.DrawLinePenKind.FUNNY_BUG2_UNFIX_RECTANGLE_FILL:
                    s = "f6"; break;
                case Layer.DrawLinePenKind.FUNNY_BUG2B_UNFIX_RECTANGLE_FILL:
                    s = "f7"; break;
                case Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_CONC:
                    s = "f8"; break;
                case Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_MID:
                    s = "f9"; break;
                case Layer.DrawLinePenKind.CIRCLE_RANDOM_DOT_SPARSE:
                    s = "f10"; break;
                case Layer.DrawLinePenKind.USER_PEN_KIND_METHOD1:
                    s = "f11"; break;
                case Layer.DrawLinePenKind.USER_PEN_KIND_METHOD2:
                    s = "f12"; break;
                default:
                    break;
            }
            return s;
        }

        public void macrosSetPenKind(string s)
        {
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "f2":
                    lDLPKFIXSQUAREFILLToolStripMenuItem_Click(lDLPKFIXSQUAREFILLToolStripMenuItem, dummyE);
                    break;
                case "f3":
                    lDLPKUNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKUNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    break;
                case "f4":
                    lDLPKCIRCLEFILLToolStripMenuItem_Click(lDLPKCIRCLEFILLToolStripMenuItem, dummyE);
                    break;
                case "f5":
                    lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKFUNNYBUGUNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    break;

                case "f6":
                    lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKFUNNYBUG2UNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    break;
                case "f7":
                    lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem_Click(lDLPKFUNNYBUG2BUNFIXRECTANGLEFILLToolStripMenuItem, dummyE);
                    break;
                case "f8":
                    lDLPKCRDCONCToolStripMenuItem_Click(lDLPKCRDCONCToolStripMenuItem, dummyE);
                    break;
                case "f9":
                    lDLPKCRDMIDToolStripMenuItem_Click(lDLPKCRDMIDToolStripMenuItem, dummyE);
                    break;
                case "f10":
                    lDLPKCRDSPARSEToolStripMenuItem_Click(lDLPKCRDSPARSEToolStripMenuItem, dummyE);
                    break;
                case "f11":
                    lDLPKUPKMETHOD1ToolStripMenuItem_Click(lDLPKUPKMETHOD1ToolStripMenuItem, dummyE);
                    break;
                case "f12":
                    lDLPKUPKMETHOD2ToolStripMenuItem_Click(lDLPKUPKMETHOD2ToolStripMenuItem, dummyE);
                    break;
                default:
                    throw new Exception("penmode not found");
                    break;
            }
        }

        public string macrosGetDotDrawMode()
        {
            string s = "";
            switch (layer1.getDotDrawMode())
            {
                case Layer.DotDrawMode.OVERWRITE:
                    s = "ow";
                    break;
                case Layer.DotDrawMode.SIMPLEMIX:
                    s = "sm";
                    break;
                default:
                    break;
            }
            return s;
        }

        public void macrosSetDotDrawMode(string s)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "ow":
                    dDMOverWriteToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "sm":
                    dDMSimpleMixToolStripMenuItem_Click(dummy, dummyE);
                    break;
                default:
                    throw new Exception("dotdrawmode not found");
                    break;
            }
        }

        public string macrosGetDotDrawModeSimpleMixRate()
        {
            string s = "";
            double d = layer1.GetDDMSM_Rate();

            if (Layer.DDMSM_High == d)
                s = "h";
            else if (Layer.DDMSM_Middle == d)
                s = "m";
            else if (Layer.DDMSM_Low == d)
                s = "l";
            else if (Layer.DDMSM_None == d)
                s = "n";

            return s;
        }

        public void macrosSetDotDrawModeSimpleMixRate(string s)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "h":
                    dDMSMHighToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "m":
                    dDMSMMiddleToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "l":
                    dDMSMLowToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "n":
                    dDMSMNoneToolStripMenuItem_Click(dummy, dummyE);
                    break;
                default:
                    throw new Exception("ddmsmr not found");
                    break;
            }
        }

        public string macrosGetTargetLayer()
        {
            string s = "";
            if (this.layer1 == this.targetLayer)
                s = "1";
            else if (this.layer2 == this.targetLayer)
                s = "2";
            else if (this.layer3 == this.targetLayer)
                s = "3";
            else if (this.layer4== this.targetLayer)
                s = "4";
            return s;
        }

        public void macrosSetTargetLayer(string s)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "1":
                    layer1ToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "2":
                    layer2ToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "3":
                    layer3ToolStripMenuItem_Click(dummy, dummyE);
                    break;
                case "4":
                    layer4ToolStripMenuItem_Click(dummy, dummyE);
                    break;
                default:
                    throw new Exception("targetlayer not found");
                    break;
            }
        }

        ///////

        public void macrosMouseDown(int x, int y)
        {
            Object o = new Object();
            MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, x, y, 0);
            pictureBox1_MouseDown(o, mea);
        }

        public void macrosMouseMove(int x, int y)
        {
            Object o = new Object();
            MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, x, y, 0);
            pictureBox1_MouseMove(o, mea);
        }

        public void macrosMouseUp(int x, int y)
        {
            Object o = new Object();
            MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, x, y, 0);
            pictureBox1_MouseUp(o, mea);
        }

        ///////

        public string macrosGetAntiAliasing()
        {
            string s = "";
            if (layer1.antiAliasing)
                s = "true";
            else
                s = "false";
            return s;
        }

        public void macrosSetAntiAliasing(string s)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "true":
                    if (checkBoxAntialiasing.Checked == false)
                    {
                        checkBoxAntialiasing.Checked = true; // この操作では、checkBoxAntialiasing_Click()はよばれない。
                    }
                    else
                    {
                    }
                    checkBoxAntialiasing_Click(dummy, dummyE);
                    break;
                case "false":
                    if (checkBoxAntialiasing.Checked == true)
                    {
                        checkBoxAntialiasing.Checked = false;
                    }
                    else
                    {
                    }
                    checkBoxAntialiasing_Click(dummy, dummyE);
                    break;
                default:
                    throw new Exception("antialiasing not found");
                    break;
            }
        }

        ///////

        public string macrosGetAntiAliasingType()
        {
            string s = "";
            if (layer1.getAntiAliasingType() == Layer.AntiAliasingType.AAT1)
                s = "1";
            else if (layer1.getAntiAliasingType() == Layer.AntiAliasingType.AAT2)
                s = "2";
            return s;
        }

        public void macrosSetAntiAliasingType(string s)
        {
            object dummy = new object();
            EventArgs dummyE = new EventArgs();
            switch (s)
            {
                case "1":
                    if(comboBoxAat.SelectedIndex ==0)
                        comboBoxAat_SelectedIndexChanged(dummy, dummyE);
                    else
                        comboBoxAat.SelectedIndex = 0; // この操作で、comboBoxAat_SelectedIndexChanged()が呼ばれる。
                    break;
                case "2":
                    if (comboBoxAat.SelectedIndex == 1)
                        comboBoxAat_SelectedIndexChanged(dummy, dummyE);
                    else
                        comboBoxAat.SelectedIndex = 1;
                    break;
                default:
                    throw new Exception("aat not found");
                    break;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 

        public void macrosSetDotDrawCycle(DotDrawCycle ddc1, DotDrawCycle ddc2, DotDrawCycle ddc3, DotDrawCycle ddc4)
        {
            try
            {
                layer1.SetLayerDotDrawCycle(ddc1);
                layer2.SetLayerDotDrawCycle(ddc2);
                layer3.SetLayerDotDrawCycle(ddc3);
                layer4.SetLayerDotDrawCycle(ddc4);
            }
            catch (Exception e)
            {
                throw e;
            }
        }
 
        private void pictureAnalyzeAsCommandToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PictureAnalyzeAsCommand paac = new PictureAnalyzeAsCommand();
            paac.Show();
        }

        public Bitmap getLasterBitmap()
        {
            Bitmap bmp = null;
            switch (nowStateOfRotate)
            {
                case StateOfRotate.ROTATE000:
                case StateOfRotate.ROTATE180:
                    bmp = laster_a;
                    break;
                case StateOfRotate.ROTATE090:
                case StateOfRotate.ROTATE270:
                    bmp = laster_b;
                    break;
                default:
                    break;
            }
            return bmp;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Resize(object sender, EventArgs e)
        {
            this.panel1.Width = this.ClientSize.Width - this.panel1.Left;
            this.panel1.Height = this.ClientSize.Height - this.panel1.Top - this.menuStrip1.Height;
        }

        /// <summary>
        /// 
        /// </summary>
        private void zoomChanged()
        {
            int width = 1;
            int height = 1;
            if (this.nowStateOfRotate == StateOfRotate.ROTATE000)
            {
                width = (int)Math.Ceiling(laster_a.Width * d_zoom);
                height = (int)Math.Ceiling(laster_a.Height * d_zoom);
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE090)
            {
                width = (int)Math.Ceiling(laster_b.Width * d_zoom);
                height = (int)Math.Ceiling(laster_b.Height * d_zoom);
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE180)
            {
                width = (int)Math.Ceiling(laster_a.Width * d_zoom);
                height = (int)Math.Ceiling(laster_a.Height * d_zoom);
            }
            else if (this.nowStateOfRotate == StateOfRotate.ROTATE270)
            {
                width = (int)Math.Ceiling(laster_b.Width * d_zoom);
                height = (int)Math.Ceiling(laster_b.Height * d_zoom);
            }
            pictureBox1.Size = new Size(width, height);
        }

        private void numericUpDownZoom_ValueChanged(object sender, EventArgs e)
        {
            d_zoom = (double)numericUpDownZoom.Value / 100.0;
            zoomChanged();
        }

        private void labelZoom50_Click(object sender, EventArgs e)
        {
            numericUpDownZoom.Value = 50;
        }

        private void labelZoom100_Click(object sender, EventArgs e)
        {
            numericUpDownZoom.Value = 100;
        }

        private void labelZoom200_Click(object sender, EventArgs e)
        {
            numericUpDownZoom.Value = 200;
        }

        private void labelZoom75_Click(object sender, EventArgs e)
        {
            numericUpDownZoom.Value = 75;
        }

        private void labelZoom150_Click(object sender, EventArgs e)
        {
            numericUpDownZoom.Value = 150;
        }

        private void labelZoom300_Click(object sender, EventArgs e)
        {
            numericUpDownZoom.Value = 300;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBoxFavoriteColors_MouseUp(object sender, MouseEventArgs e)
        {
            Bitmap favorite = (Bitmap)pictureBoxFavoriteColors.Image;
            try
            {
                Color color = favorite.GetPixel(e.X, e.Y);
                alpha = color.A;
                int rgb = color.R * 0x10000 + color.G * 0x100 + color.B;
                setColorsFromRgb(myColor, rgb);
            }
            catch (Exception exc)
            {
                return;
            }
        }

        private void initFavoriteColors()
        {
            int back = 4;
            Bitmap background = new Bitmap(back * 2, back * 2);
            for (int x = 0; x < background.Width; x++)
            {
                for (int y = 0; y < background.Height; y++)
                {
                    if(x / back == y / back)
                    {
                        background.SetPixel(x,y,Color.FromKnownColor(KnownColor.WhiteSmoke));
                    }
                    else
                    {
                        background.SetPixel(x,y,Color.FromKnownColor(KnownColor.Gray));
                    }
                }
            }
            pictureBoxFavoriteColors.BackgroundImageLayout = ImageLayout.Tile;
            pictureBoxFavoriteColors.BackgroundImage = background;

            Bitmap favorite;
            Bitmap temp;
            try
            {
                temp = (Bitmap)Bitmap.FromFile("favoritecolors.png");
                favorite = new Bitmap(pictureBoxFavoriteColors.Width, pictureBoxFavoriteColors.Height);
                initFavorite2(favorite, temp);
                temp.Dispose();
            }
            catch (Exception exc)
            {
                favorite = new Bitmap(pictureBoxFavoriteColors.Width,pictureBoxFavoriteColors.Height);
                initFavorite(favorite);
            }
            //pictureBoxFavoriteColors.SizeMode = PictureBoxSizeMode.StretchImage;
            pictureBoxFavoriteColors.Image = favorite;

            numericUpDownFavoriteColorsAlpha.Value = numericUpDownFavoriteColorsAlpha.Maximum;
        }

        private void initFavorite(Bitmap favorite)
        {

            int itemcount = 10;
            for (int y = 0; y < pictureBoxFavoriteColors.Height; y++)
            {
                for (int x = 0; x < pictureBoxFavoriteColors.Width; x++)
                {
                    
                    switch (x / (pictureBoxFavoriteColors.Width / itemcount))
                    {
                        case 0:
                            favorite.SetPixel(x, y, Color.Red);
                            break;
                        case 1:
                            favorite.SetPixel(x, y, Color.Yellow);
                            break;
                        case 2:
                            favorite.SetPixel(x, y, Color.Green);
                            break;
                        case 3:
                            favorite.SetPixel(x, y, Color.Cyan);
                            break;
                        case 4:
                            favorite.SetPixel(x, y, Color.Blue);
                            break;
                        case 5:
                            favorite.SetPixel(x, y, Color.Magenta);
                            break;
                        case 6:
                            favorite.SetPixel(x, y, Color.White);
                            break;
                        case 7:
                            favorite.SetPixel(x, y, Color.Gray);
                            break;
                        case 8:
                            favorite.SetPixel(x, y, Color.Black);
                            break;
                        case 9:
                            favorite.SetPixel(x, y, Color.FromArgb(0, transparent, transparent, transparent));
                            break;
                        default:
                            break;
                    }
                }
            }
        }

        private void numericUpDownFavoriteColorsAlpha_ValueChanged(object sender, EventArgs e)
        {
            int itemcount = 10;
            Bitmap favorite = (Bitmap)pictureBoxFavoriteColors.Image;
            for (int y = 0; y < pictureBoxFavoriteColors.Height; y++)
            {
                for (int x = 0; x < pictureBoxFavoriteColors.Width; x++)
                {

                    switch (x / (pictureBoxFavoriteColors.Width / itemcount))
                    {
                        case 0:
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                        case 8:
                            favorite.SetPixel(x, y, Color.FromArgb(
                                (int)numericUpDownFavoriteColorsAlpha.Value,
                                favorite.GetPixel(x, y).R,
                                favorite.GetPixel(x, y).G,
                                favorite.GetPixel(x, y).B));
                            break;
                        case 9:
                            favorite.SetPixel(x, y, Color.FromArgb(0, transparent, transparent, transparent));
                            break;
                        default:
                            break;
                    }
                }
            }
            pictureBoxFavoriteColors.Invalidate();
        }

        private void initFavorite2(Bitmap favorite, Bitmap temp)
        {
            for (int x = 0; x < favorite.Width; x++)
            {
                for (int y = 0; y < favorite.Height; y++)
                {
                    favorite.SetPixel(x, y,
                        temp.GetPixel(x * temp.Width / favorite.Width,
                        y * temp.Height / favorite.Height));
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="b"></param>
        public void set_macrosCommandToolStripMenuItem_Enabled(bool b)
        {
            macrosCommandToolStripMenuItem.Enabled = b;
        }
    }
}
